// ======================== Atmega128 ׷ LCD ׽Ʈ α׷ ==============
//  CPU : ATmega128-16M - 128*64 ׷ LCD
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR 
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega128


#pragma used+
sfrb PINF=0;
sfrb PINE=1;
sfrb DDRE=2;
sfrb PORTE=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR0L=9;
sfrb UCSR0B=0xa;
sfrb UCSR0A=0xb;
sfrb UDR0=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb SFIOR=0x20;
sfrb WDTCR=0x21;
sfrb OCDR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb ASSR=0x30;
sfrb OCR0=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x36;
sfrb TIMSK=0x37;
sfrb EIFR=0x38;
sfrb EIMSK=0x39;
sfrb EICRB=0x3a;
sfrb RAMPZ=0x3b;
sfrb XDIV=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-


// Interrupt vectors definitions



// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


/* CodeVisionAVR C Compiler
   Prototypes for standard library functions

   (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.
*/




#pragma used+

int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for character type functions


#pragma used+

unsigned char isalnum(char c);
unsigned char isalpha(char c);
unsigned char isascii(char c);
unsigned char iscntrl(char c);
unsigned char isdigit(char c);
unsigned char islower(char c);
unsigned char isprint(char c);
unsigned char ispunct(char c);
unsigned char isspace(char c);
unsigned char isupper(char c);
unsigned char isxdigit(char c);
unsigned char toint(char c);
char tolower(char c);
char toupper(char c);

#pragma used-


/* CodeVisionAVR C Compiler
   (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L. */






/*
CodeVisionAVR C Compiler
Prototypes for mathematical functions

Portions (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.
Portions (C) 2000-2001 Yuri G. Salov
*/



#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib


// CodeVisionAVR C Compiler
// (C) 1998-2005 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for string functions



#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned char strcspn(char *str,char *set);
unsigned char strcspnf(char *str,char flash *set);
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
signed char strpos(char *str,char c);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
signed char strrpos(char *str,char c);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
unsigned char strspn(char *str,char *set);
unsigned char strspnf(char *str,char flash *set);
char *strtok(char *str1,char flash *str2);
 

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);

#pragma used-
#pragma library string.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-


//  
// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   


// Լ 
int putchar_0(char data);					// COM1 ۽
int getchar_0(void);						// COM1 

//  
char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
// PortA 
// LCD_D[0..7] : LCD Data Bus
	PORTA=0xff;						// Ʈ  reg             
	DDRA=0x00;                                              // Ʈ  reg(0Է,1)

// PortC 
// LCD_D[8..15] : LCD Data Bus(color lcd)
// PortC.0 : GLCD_CS1( High)
// PortC.1 : GLCD_CS2(LEDE)
	PORTC=0xfd;						// Ʈ  reg             
	DDRC=0x03;                                              // Ʈ  reg(0Է,1)

// PortE 
// PortE.3(OUT) : LCD DIR(÷ ̺ IC  Low)
// PortE.4(OUT) : LCD E
// PortE.5(OUT) : LCD RS(A0)
// PortE.6(OUT) : GLCD/CLCD Reset
// PortE.7(IN)  : TSC2003 Interrupt PULL UP(external) 
	PORTE=0x40;						// Ʈ  reg             
	DDRE=0x78;                                              // Ʈ  reg(0Է,1)

// PortG 
// PortG.0(OUT) : LCD R/W,CLCD_WR
// PortG.1(OUT) : LCD RD
// PortG.2(OUT) : LCD CS
	(*(unsigned char *) 0x65)=0x07;						// Ʈ  reg             
	(*(unsigned char *) 0x64)=0x07;                                              // Ʈ  reg(0Է,1)

//  ʱȭ(COM1)
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSR0A=0x00;
	UCSR0B=0x98;
	(*(unsigned char *) 0x95)=0x06;
	(*(unsigned char *) 0x90)=0x00;
	UBRR0L=0x33;

// External SRAM page configuration: 
//              -              / 0000h - FFFFh
// Lower page wait state(s): None
// Upper page wait state(s): 1r/w
//	MCUCR=0xc0;
//	XMCRA=0x02;

// Analog Comparator 
	ACSR=0x80;
	SFIOR=0x00;

// Global enable interrupts
#asm("sei")
}

// =============================== COM1 ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
#pragma savereg-
interrupt [19] void uart0_rx_isr(void)
{
char status,data;
#asm
	push r26
	push r27
	push r30
	push r31
	in   r26,sreg
	push r26
#endasm

	status=UCSR0A;
	data=UDR0;
	if((status & ((1<<4) | (1<<2) | (1<<3)))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

#asm
	pop  r26
	out  sreg,r26
	pop  r31
	pop  r30
	pop  r27
	pop  r26
#endasm
}
#pragma savereg+
// ======================= ׷ LCD  α׷ ============================
//  : ABG128064A
// -----------------------------------------------------------------------------
// Ʈ
unsigned char flash AscFont16[128][16] =  {
unsigned char flash AscFont16[128][16] =  {
unsigned char flash AscFont16[128][16] =  {
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{240,   8,  40,   8,   8,  40,   8, 240,   7,   8,   9,  11,  11,   9,   8,   7}, 
	{240, 248, 216, 248, 248, 216, 248, 240,   7,  15,  14,  12,  12,  14,  15,   7}, 
	{  0, 224, 240, 240, 224, 240, 240, 224,   0,   1,   3,   7,  15,   7,   3,   1}, 
	{  0, 128, 192, 224, 240, 224, 192, 128,   0,   0,   1,   3,   7,   3,   1,   0}, 
	{192, 192, 240,  56,  56, 240, 192, 192,   1,   1,   9,  14,  14,   9,   1,   1}, 
	{192, 224, 240, 248, 248, 240, 224, 192,   0,   1,   9,  15,  15,   9,   1,   0}, 
	{  0,   0, 128, 192, 192, 128,   0,   0,   0,   0,   1,   3,   3,   1,   0,   0}, 
	{254, 254, 126,  62,  62, 126, 254, 254, 127, 127, 126, 124, 124, 126, 127, 127}, 
	{  0, 192,  96,  32,  32,  96, 192,   0,   0,   3,   6,   4,   4,   6,   3,   0}, 
	{254,  62, 158, 222, 222, 158,  62, 254, 127, 124, 121, 123, 123, 121, 124, 127}, 
	{  0,   0, 128, 192, 232, 184,  24, 120,   0,   7,  15,   8,   8,  15,   7,   0}, 
	{  0, 112, 248, 136, 136, 248, 112,   0,   0,   2,   2,  15,  15,   2,   2,   0}, 
	{112, 248, 136, 248, 248,   8, 248, 248,   0,   0,   0,  15,  15,   0,  15,  15}, 
	{  0,   0, 248, 248,  40,  40,  56,  56,  12,  14,  15,   7,   0,   0,   0,   0}, 
	{  0, 248, 248,  40,  40,  40, 248, 248,  28,  31,  15,   0,   0,  14,  15,   7}, 
	{128, 128, 128, 128, 128, 128, 128, 128,   7,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 248, 240, 224, 192, 192, 128,   0,   0,  15,   7,   3,   1,   1,   0,   0}, 
	{  0,   0, 128, 192, 192, 224, 240, 248,   0,   0,   0,   1,   1,   3,   7,  15}, 
	{  0,  32,  16, 248,  16,  32,   0,   0,   0,   2,   4,  15,   4,   2,   0,   0}, 
	{  0,   0, 248,   0,   0, 248,   0,   0,   0,   0,  13,   0,   0,  13,   0,   0}, 
	{  0, 128, 128, 128, 128, 128, 128, 128,   0,   0,   0,   0,   0,   0,   0,   7}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   8,   8,   8,   8,   8,   8,   8}, 
	{  0,  32,  16, 248,  16,  32,   0,   0,   0,  18,  20,  31,  20,  18,   0,   0}, 
	{  0,  32,  16, 248,  16,  32,   0,   0,   0,   0,   0,  15,   0,   0,   0,   0}, 
	{  0,   0,   0, 248,   0,   0,   0,   0,   0,   2,   4,  15,   4,   2,   0,   0}, 
	{  0, 128, 128, 128, 128, 160, 192, 128,   0,   0,   0,   0,   0,   2,   1,   0}, 
	{  0, 128, 192, 160, 128, 128, 128, 128,   0,   0,   1,   2,   0,   0,   0,   0}, 
	{192,   0,   0,   0,   0,   0,   0,   0,   3,   2,   2,   2,   2,   2,   2,   2}, 
	{128, 192, 160, 128, 128, 160, 192, 128,   0,   1,   2,   0,   0,   2,   1,   0}, 
	{  0,   0, 128, 224, 240, 224, 128,   0,   0,   6,   7,   7,   7,   7,   7,   6}, 
	{  0,  48, 240, 240, 240, 240, 240,  48,   0,   0,   0,   3,   7,   3,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0, 112, 248, 112,   0,   0,   0,   0,   0,   0,  13,   0,   0,   0,   0}, 
	{  0,  28,  60,   0,   0,  60,  28,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  32, 248,  32,  32, 248,  32,   0,   0,   2,  15,   2,   2,  15,   2,   0}, 
	{  0, 112, 136, 136, 142, 136, 144,   0,   0,   4,   8,   8,  56,   8,   7,   0}, 
	{  0,  96,  96,   0,   0, 128,  64,   0,   0,   8,   4,   2,   1,  12,  12,   0}, 
	{  0,   0, 176, 104, 200,  72, 176,   0,   0,   7,   8,   8,   9,   7,  12,   0}, 
	{  0,   0,  32,  28,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0, 224,  16,   8,   8,   0,   0,   0,   0,   3,   4,   8,   8,   0,   0}, 
	{  0,   0,   0,   8,   8,  16, 224,   0,   0,   0,   0,   8,   8,   4,   3,   0}, 
	{128, 160, 192, 224, 192, 160, 128,   0,   0,   2,   1,   3,   1,   2,   0,   0}, 
	{128, 128, 128, 240, 128, 128, 128,   0,   0,   0,   0,   7,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  16,  14,   0,   0,   0}, 
	{128, 128, 128, 128, 128, 128, 128, 128,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  12,  12,   0,   0,   0}, 
	{  0,   0,   0,   0, 128,  64,  32,  16,   0,   4,   2,   1,   0,   0,   0,   0}, 
	{240,   8,   8, 136,  72,  40, 240,   0,   7,  10,   9,   8,   8,   8,   7,   0}, 
	{  0,  32,  16, 248,   0,   0,   0,   0,   8,   8,   8,  15,   8,   8,   8,   0}, 
	{ 16,   8,   8, 136,  72,  72,  48,   0,  12,  10,   9,   8,   8,   8,  12,   0}, 
	{ 16,   8, 136, 136, 136, 136, 240,   0,   4,   8,   8,   8,   8,   8,   7,   0}, 
	{128,  64,  32,  16,   8, 248,   0,   0,   1,   1,   1,   1,   9,  15,   9,   0}, 
	{248, 136, 136, 136, 136, 136,   8,   0,   4,   8,   8,   8,   8,   8,   7,   0}, 
	{224, 144, 136, 136, 136, 128,   0,   0,   7,   8,   8,   8,   8,   8,   7,   0}, 
	{ 24,   8,   8,   8, 136,  72,  56,   0,   0,   0,   0,  15,   0,   0,   0,   0}, 
	{112, 136, 136, 136, 136, 136, 112,   0,   7,   8,   8,   8,   8,   8,   7,   0}, 
	{112, 136, 136, 136, 136, 136, 240,   0,   0,   8,   8,   8,   8,   4,   3,   0}, 
	{  0,   0,   0,  48,   0,   0,   0,   0,   0,   0,   0,   6,   0,   0,   0,   0}, 
	{  0,   0,   0,  48,   0,   0,   0,   0,   0,   0,   8,   6,   0,   0,   0,   0}, 
	{  0, 128,  64,  32,  16,   8,   0,   0,   0,   0,   1,   2,   4,   8,   0,   0}, 
	{  0,  64,  64,  64,  64,  64,  64,   0,   0,   2,   2,   2,   2,   2,   2,   0}, 
	{  0,   0,   8,  16,  32,  64, 128,   0,   0,   0,   8,   4,   2,   1,   0,   0}, 
	{ 48,   8,   8,   8, 136,  72,  48,   0,   0,   0,   0,   0,  13,   0,   0,   0}, 
	{240,   8,   8, 200,  72,  72, 240,   0,   7,   8,   8,  11,  10,  10,   1,   0}, 
	{192,  32,  16,   8,  16,  32, 192,   0,  15,   1,   1,   1,   1,   1,  15,   0}, 
	{  8, 248, 136, 136, 136, 136, 112,   0,   8,  15,   8,   8,   8,   8,   7,   0}, 
	{224,  16,   8,   8,   8,   8,  48,   0,   3,   4,   8,   8,   8,   8,   6,   0}, 
	{  8, 248,   8,   8,   8,  16, 224,   0,   8,  15,   8,   8,   8,   4,   3,   0}, 
	{  8, 248, 136, 136, 200,   8,  56,   0,   8,  15,   8,   8,   9,   8,  14,   0}, 
	{  8, 248, 136, 136, 200,   8,  24,   0,   8,  15,   8,   8,   1,   0,   0,   0}, 
	{224,  16,   8,   8,   8,   8,  48,   0,   3,   4,   8,   9,   9,   5,  15,   0}, 
	{248, 128, 128, 128, 128, 128, 248,   0,  15,   0,   0,   0,   0,   0,  15,   0}, 
	{  0,   0,   8, 248,   8,   0,   0,   0,   0,   0,   8,  15,   8,   0,   0,   0}, 
	{  0,   0,   0,   0,   8, 248,   8,   0,   0,   6,   8,   8,   8,   7,   0,   0}, 
	{  0, 248, 128,  64,  32,  16,   8,   0,   0,  15,   0,   1,   2,   4,   8,   0}, 
	{  8, 248,   8,   0,   0,   0,   0,   0,   8,  15,   8,   8,   8,   8,  14,   0}, 
	{248,  16,  32, 192,  32,  16, 248,   0,  15,   0,   0,   0,   0,   0,  15,   0}, 
	{248,  32,  64, 128,   0,   0, 248,   0,  15,   0,   0,   0,   1,   2,  15,   0}, 
	{224,  16,   8,   8,   8,  16, 224,   0,   3,   4,   8,   8,   8,   4,   3,   0}, 
	{  8, 248, 136, 136, 136, 136, 112,   0,   8,  15,   8,   0,   0,   0,   0,   0}, 
	{240,   8,   8,   8,   8,   8, 240,   0,   3,   4,   4,   4,   5,   6,  11,   0}, 
	{  8, 248, 136, 136, 136, 136, 112,   0,   8,  15,   8,   0,   1,   2,  12,   0}, 
	{ 48,  72,  72, 136, 136,   8,  48,   0,   6,   8,   8,   8,   8,   9,   6,   0}, 
	{ 24,   8,   8, 248,   8,   8,  24,   0,   0,   0,   8,  15,   8,   0,   0,   0}, 
	{248,   0,   0,   0,   0,   0, 248,   0,   7,   8,   8,   8,   8,   8,   7,   0}, 
	{248,   0,   0,   0,   0,   0, 248,   0,   3,   4,   8,   8,   8,   4,   3,   0}, 
	{248,   0,   0, 192,   0,   0, 248,   0,  15,   4,   2,   1,   2,   4,  15,   0}, 
	{ 24,  32,  64, 128,  64,  32,  24,   0,  12,   2,   1,   0,   1,   2,  12,   0}, 
	{ 24,  32,  64, 128,  64,  32,  24,   0,   0,   8,   8,  15,   8,   8,   0,   0}, 
	{ 24,   8,   8, 136,  72,  40,  24,   0,  12,  10,   9,   8,   8,   8,  12,   0}, 
	{  0,   0, 248,   8,   8,   8,   0,   0,   0,   0,  15,   8,   8,   8,   0,   0}, 
	{ 16,  32,  64, 128,   0,   0,   0,   0,   0,   0,   0,   0,   1,   2,   4,   8}, 
	{  0,   0,   8,   8,   8, 248,   0,   0,   0,   0,   8,   8,   8,  15,   0,   0}, 
	{  0,  16,   8,   4,   2,   4,   8,  16,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,  32,  32,  32,  32,  32,  32,  32,  32}, 
	{  0,   0,   0,   6,  14,   8,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  64,  64,  64,  64, 128,   0,   0,   6,   9,   9,   9,   1,  15,   8,   0}, 
	{  8, 248,  64,  64,  64, 128,   0,   0,   8,  15,   0,   8,   8,   8,   7,   0}, 
	{128,  64,  64,  64,  64,  64, 128,   0,   7,   8,   8,   8,   8,   8,   4,   0}, 
	{  0, 128,  64,  72,  72, 248,   0,   0,   7,   8,   8,   8,   0,  15,   8,   0}, 
	{128,  64,  64,  64,  64,  64, 128,   0,   7,   9,   9,   9,   9,   9,   5,   0}, 
	{128, 240, 136, 136, 136,  48,   0,   0,   8,  15,   8,   8,   0,   0,   0,   0}, 
	{128,  64,  64,  64,   0, 192,  64,   0,  19,  36,  36,  36,  36,  31,   0,   0}, 
	{  8, 248, 128, 128,  64,  64, 128,   0,   8,  15,   0,   0,   0,   0,  15,   0}, 
	{  0,   0,  64,  64, 216,   0,   0,   0,   0,   0,   8,   8,  15,   8,   0,   0}, 
	{  0,   0,   0,  64,  64, 216,   0,   0,  24,  32,  32,  32,  32,  31,   0,   0}, 
	{  0,   8, 248,   0,   0, 128,  64,   0,   0,   8,  15,   1,   3,   4,   8,   0}, 
	{  0,   0,   8,   8, 248,   0,   0,   0,   0,   0,   8,   8,  15,   8,   0,   0}, 
	{128,  64,  64, 128,  64,  64, 128,   0,  15,   0,   0,  15,   0,   0,  15,   0}, 
	{ 64, 192, 128,  64,  64,  64, 128,   0,   0,  15,   0,   0,   0,   0,  15,   0}, 
	{128,  64,  64,  64,  64,  64, 128,   0,   7,   8,   8,   8,   8,   8,   7,   0}, 
	{ 64, 192, 192,  64,  64,  64, 128,   0,  32,  63,  36,  36,   4,   4,   3,   0}, 
	{128,  64,  64,  64,  64, 192,  64,   0,   3,   4,   4,  36,  36,  63,  32,   0}, 
	{ 64, 192, 128,  64,  64,  64, 128,   0,   8,  15,   8,   8,   0,   0,   1,   0}, 
	{128,  64,  64,  64,  64,  64, 128,   0,   4,   9,   9,   9,  10,  10,   4,   0}, 
	{ 64,  64,  64, 248,  64,  64,   0,   0,   0,   0,   0,  15,   8,   8,   4,   0}, 
	{192,   0,   0,   0,   0, 192,   0,   0,   7,   8,   8,   8,   0,  15,   8,   0}, 
	{192,   0,   0,   0,   0,   0, 192,   0,   1,   2,   4,   8,   4,   2,   1,   0}, 
	{192,   0,   0,   0,   0,   0, 192,   0,   7,   8,   8,   6,   8,   8,   7,   0}, 
	{ 64, 128,   0,   0,   0, 128,  64,   0,   8,   4,   3,   2,   3,   4,   8,   0}, 
	{192,   0,   0,   0,   0,   0, 192,   0,   3,  36,  36,  36,  36,  20,  15,   0}, 
	{192,  64,  64,  64,  64, 192,  64,   0,   8,   8,  12,  10,   9,   8,  12,   0}, 
	{  0, 128, 128, 240,   8,   8,   8,   0,   0,   0,   0,   7,   8,   8,   8,   0}, 
	{  0,   0,   0, 120,   0,   0,   0,   0,   0,   0,   0,  15,   0,   0,   0,   0}, 
	{  0,   8,   8,   8, 240, 128, 128,   0,   0,   8,   8,   8,   7,   0,   0,   0}, 
	{  0,  16,  24,   8,  24,  16,  24,   8,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 128,  64,  32,  64, 128,   0,   0,   7,   4,   4,   4,   4,   4,   7,   0}
};

unsigned char flash HanFont1[152][32] = {
unsigned char flash HanFont1[152][32] = {
	{  0,   4,   4,   4,   4, 196,  60,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   8,   8,   4,   3,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   4,   4, 132, 124,   4, 132, 124,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,  12,   3,   0,  12,   3,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 252,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  15,   8,   8,   8,   8,   8,   8,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 252,   4,   4,   4,   4,   4,   4,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  15,   8,   8,   8,   8,   8,   8,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 252,   4,   4, 252,   4,   4,   4,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  15,   8,   8,  15,   8,   8,   8,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 196,  68,  68,  68,  68,  68, 124,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  15,   8,   8,   8,   8,   8,   8,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 252,   4,   4,   4,   4,   4, 252,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  15,   8,   8,   8,   8,   8,  15,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 252,  64,  64,  64,  64,  64, 252,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  15,   8,   8,   8,   8,   8,  15,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 252,  64,  64, 252, 252,  64,  64, 252,   0,   0,   0,   0,   0,   0,   0 ,   0,  15,   8,   8,  15,  15,   8,   8,  15,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0, 192, 124, 192,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  12,   3,   0,   0,   0,   3,  12,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0, 128, 252, 128, 128, 124, 128,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  14,   1,   0,  15,   0,   0,   1,  14,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 240,   8,   4,   4,   4,   8, 240,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   3,   4,   8,   8,   8,   4,   3,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   4,   4, 196, 124, 196,   4,   4,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  12,   3,   0,   0,   0,   3,  12,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  4,   4, 252,   4,   4,   4, 252,   4,   4,   0,   0,   0,   0,   0,   0,   0 ,  12,   3,   1,   3,  12,   3,   1,   1,  14,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   4, 132, 228,  62, 228, 132,   4,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  14,   3,   0,   0,   0,   3,  14,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  68,  68,  68,  68, 196,  60,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   8,   8,   4,   3,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 252,  68,  68,  68,  68,  68,   4,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  15,   8,   8,   8,   8,   8,   8,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   4, 252,   4,   4,   4, 252,   4,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   8,  15,   8,   8,   8,  15,   8,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 200,  40,  24,  28,  24,  40, 200,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   3,   4,   8,   8,   8,   4,   3,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4, 252,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0}, 
	{  0,   0,   4,   4,   4,   4, 252,   0,   0,   4,   4,   4,   4, 252,   0,   0 ,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   1,   0,   0}, 
	{  0,   0, 252,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0}, 
	{  0,   0, 252,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0}, 
	{  0,   0, 252,   4,   4,   4,   4,   0, 252,   4,   4,   4,   4,   4,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   0,   1,   1,   1,   1,   1,   1,   0,   0}, 
	{  0,   0, 228,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  60,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0}, 
	{  0,   0, 252,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4, 252,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0}, 
	{  0,   0, 252,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32, 252,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0}, 
	{  0,   0, 252,  32,  32,  32,  32, 252, 252,  32,  32,  32,  32, 252,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0}, 
	{  0,   0, 128, 128,  64,  32,  16,  28,  16,  32,  64, 128, 128,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0, 128,  64, 124,  64, 128, 128,  64, 124,  64, 128,   0,   0,   0 ,   0,   0,   1,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   1,   0,   0}, 
	{  0,   0, 112, 136,   4,   4,   4,   4,   4,   4,   4,   4, 136, 112,   0,   0 ,   0,   0,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0}, 
	{  0,   0,   4,   4, 132,  68,  36,  60,  36,  68, 132,   4,   4,   0,   0,   0 ,   0,   0,   1,   1,   0,   0,   0,   0,   0,   0,   0,   1,   1,   0,   0,   0}, 
	{  0,   0,   4, 132,  68, 124,  68, 196,  68,  68, 124,  68, 132,   4,   0,   0 ,   0,   0,   1,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   1,   0,   0}, 
	{  0,   0,   8,   8, 136,  72,  40,  60,  40,  72, 136,   8,   8,   0,   0,   0 ,   0,   0,   1,   1,   0,   0,   0,   0,   0,   0,   0,   1,   1,   0,   0,   0}, 
	{  0,   0,   4,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36, 252,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0}, 
	{  0,   0, 252,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,   4,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0}, 
	{  0,   0,   4,   4, 252,   4,   4,   4,   4,   4,   4, 252,   4,   4,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0}, 
	{  0,   0,   8, 232,  24,  24,  24,  28,  28,  24,  24,  24, 232,   8,   0,   0 ,   0,   0,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0}, 
	{  0,   0,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4, 124,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   4,   4,   4,   4, 124,   0,   0,   4,   4,   4,   4, 124,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0, 124,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0, 124,  68,  68,  68,  68,  68,  68,  68,  68,  68,  68,  68,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0, 124,  68,  68,  68,  68,   0, 124,  68,  68,  68,  68,  68,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0, 116,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,  92,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0, 124,  68,  68,  68,  68,  68,  68,  68,  68,  68,  68, 124,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0, 124,  80,  80,  80,  80,  80,  80,  80,  80,  80,  80, 124,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0, 124,  80,  80,  80,  80, 124, 124,  80,  80,  80,  80, 124,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  64,  64,  32,  16,   8,  12,   8,  16,  32,  64,  64,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  64,  32,  16,  28,  16,  96,  32,  16,  28,  16,  32,  64,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  16,  40,  68,  68,  68,  68,  68,  68,  68,  68,  40,  16,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  68,  68,  36,  20,  12,   4,  12,  20,  36,  68,  68,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  68,  36,  20,  28,  20, 100,  36,  20,  28,  20,  36,  68,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  36,  36,  20,  20,  12,   6,  12,  20,  20,  36,  36,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20, 124,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0, 124,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  68,  68, 124,  68,  68,  68,  68,  68,  68, 124,  68,  68,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   8,  40,  88,  88,  88,  92,  92,  88,  88,  88,  40,   8,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   4,   4,   4,   4,   4,   4,   4, 252,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   4,   4,   4, 252,   4,   4,   4, 252,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   1,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 252,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 252,   4,   4,   4,   4,   4,   4,   4,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 252,   4,   4,   0, 252,   4,   4,   4,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 228,  36,  36,  36,  36,  36,  36,  60,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 252,   4,   4,   4,   4,   4,   4, 252,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 252,  32,  32,  32,  32,  32,  32, 252,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 252,  32,  32, 252, 252,  32,  32, 252,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0, 128,  64, 124,  64, 128,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 128, 124,  64, 128, 128, 124, 128,   0,   0,   0,   0,   0,   0,   0,   0 ,   1,   0,   0,   1,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 112, 136,   4,   4,   4,   4, 136, 112,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   4, 132,  68, 124,  68, 132,   4,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   4, 132, 252, 132,   4, 252, 132, 132,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   0,   0,   0,   1,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0}, 
	{  0,   8, 136,  72, 124,  72, 136,   8,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  36,  36,  36,  36,  36,  36,  36, 252,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 252,  36,  36,  36,  36,  36,  36,   4,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   4, 252,   4,   4,   4,   4, 252,   4,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 100, 148,  12,  14,  14,  12, 148, 100,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   4,   4,   4,   4,   4,   4,   4, 124,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   4,   4,   4, 124,   4,   4,   4, 124,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 124,  64,  64,  64,  64,  64,  64,  64,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 124,  68,  68,  68,  68,  68,  68,  68,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 124,  68,  68,  64, 124,  68,  68,  68,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 116,  84,  84,  84,  84,  84,  84,  92,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 124,  68,  68,  68,  68,  68,  68, 124,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 124,  80,  80,  80,  80,  80,  80, 124,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 124,  80,  80, 124, 124,  80,  80, 124,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  64,  32,  16,  28,  16,  32,  64,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  64,  32,  28,  80,  32,  32,  28,  32,  64,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  56,  68,  68,  68,  68,  68,  56,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  68,  36,  20,  28,  20,  36,  68,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  68,  36,  60, 100,  36,  60,  36,  68,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  72,  40,  24,  12,  24,  40,  72,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  20,  20,  20,  20,  20,  20,  20, 124,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 124,  84,  84,  84,  84,  84,  84,  68,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  68, 124,  68,  68,  68,  68, 124,  68,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   8,  56,  72,  76,  76,  72,  56,   8,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 130, 130,  66,  66,  50,  14,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   2, 130,  66,  62,   2, 130,  66,  62,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 254, 128, 128, 128, 128, 128, 128, 128,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 254, 130, 130, 130, 130, 130, 130, 130,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 254, 130, 130,   0, 254, 130, 130, 130,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 242, 146, 146, 146, 146, 146, 146, 158,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 254, 130, 130, 130, 130, 130, 130, 254,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 254, 144, 144, 144, 144, 144, 144, 254,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 254, 144, 144, 254, 254, 144, 144, 254,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 128,  64,  32,  62,  32,  64, 128,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{128,  64,  62, 160, 192,  64,  62,  64, 128,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  56,  68, 130, 130, 130, 130,  68,  56,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 130,  66,  34,  62,  34,  66, 130,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 130,  66, 126,  66, 130,  66, 126,  66, 130,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 132,  68,  36,  62,  36,  68, 132,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 146, 146, 146,  82,  82,  50,  30,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 254, 146, 146, 146, 146, 146, 146, 130,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 130, 254, 130, 130, 130, 130, 254, 130,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   4, 116, 140, 142, 142, 140, 116,   4,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,  62,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   2,   2,   2,   2,   2,  62,   0,   2,   2,   2,   2,  62,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  62,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  62,  34,  34,  34,  34,   0,  62,  34,  34,  34,  34,  34,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  58,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  46,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,  62,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  62,  40,  40,  40,  40,  40,  40,  40,  40,  40,  40,  62,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  62,  40,  40,  40,  40,  62,  62,  40,  40,  40,  40,  62,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,  32,  32,  16,  24,  14,   8,  16,  16,  32,  32,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  32,  16,  30,  16,  32,  32,  32,  32,  16,  30,  16,  32,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,  28,  34,  34,  34,  34,  34,  34,  34,  34,  28,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  34,  34,  18,  18,  10,  14,  10,  18,  18,  34,  34,  34,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  34,  18,  30,  18,  50,  34,  34,  50,  18,  30,  18,  34,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  36,  36,  20,  20,  28,  14,  12,  20,  20,  20,  36,  36,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  62,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  62,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  34,  34,  62,  34,  34,  34,  34,  34,  34,  62,  34,  34,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   4,  28,  44,  36,  36,  38,  38,  36,  36,  44,  28,   4,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   2,   2,   2,   2,   2,   2,   2,  30,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   2,   2,   2,  30,   2,   2,   2,  30,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  30,  16,  16,  16,  16,  16,  16,  16,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  30,  18,  18,  18,  18,  18,  18,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  30,  18,  18,  16,  30,  18,  18,  18,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  58,  42,  42,  42,  42,  42,  42,  46,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  30,  18,  18,  18,  18,  18,  18,  30,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  30,  20,  20,  20,  20,  20,  20,  30,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  30,  20,  20,  30,  30,  20,  20,  30,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  16,  16,   8,  14,   8,  16,  16,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  16,   8,   6,   8,  16,   8,   6,   8,  16,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,  12,  18,  18,  18,  18,  12,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  18,  18,  10,  14,  10,  18,  18,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  18,  18,  14,  18,  18,  14,  18,  18,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  20,  20,  28,  14,  28,  20,  20,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  10,  10,  10,  10,  10,  42,  42,  30,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  62,  42,  42,  42,  42,  42,  42,  34,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  18,  30,  18,  18,  18,  18,  30,  18,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   4,  28,  36,  38,  38,  36,  28,   4,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}
};
 
unsigned char flash HanFont2[84][32] = {
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  64,  64,  64,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  64,  64, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,   0,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  16,  16,  16,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   1,   1,   1,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  16,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   1,   1,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  64,  64,  64, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  64,  64, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  16,  16,  16,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,   1,   1,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,  16,  16,  16, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   1,   1,   1,  63,   0,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,  16,  16,  16,  16,  16,  16,  30,  16,  16,  16,  16,  16,  16,  16,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  64,  64,   0 ,  0,  16,  16,  16,  16,  30,  16,  16,  16,  16,  16,  16,  63,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  64,  64, 254,   0,   0 ,  0,  16,  16,  16,  16,  30,  16,  16,  16,   0,  63,   0,   0,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,  16,  16,  16,  16,  30,  16,  16,  16,  16,  16,  16,  16,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,  16,  16,  16,  16,  30,  16,  16,  16,  16,  30,  16,  16,  16,  16,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   2,   2,   2,   2,   2,   2,  62,   2,   2,   2,   2,   2,   2,   2,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,   2,   2,   2,   2,  62,   2,   2,  10,  10,  10,  10,  10,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0, 254,   0,   0 ,  0,   2,   2,   2,   2,  62,   2,   2,  10,  10,  10,  63,   0,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,   2,   2,   2,   2,  62,   2,   2,   2,   2,   2,   2,   2,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   2,   2,   2,  62,   2,   2,   2,   2,   2,   2,  62,   2,   2,   2,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  64,  64,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  64,  64, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,   0,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  16,  16,  16,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   1,   1,   1,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  16,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   1,   1,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  64,  64,  64,  64, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,  64,  64,  64, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  16,  16,  16,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,   1,   1,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  16,  16, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,  63,   0,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,  16,  16,  16,  16,  16,  16,  30,  16,  16,  16,  16,  16,  16,  16,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  64,  64,   0 ,  0,  16,  16,  16,  16,  30,  16,  16,  16,  16,  16,  16,  63,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  64, 254,   0,   0 ,  0,  16,  16,  16,  16,  30,  16,  16,  16,  16,  16,  63,   0,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,  16,  16,  16,  16,  30,  16,  16,  16,  16,  16,  16,  16,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,  16,  16,  16,  30,  16,  16,  16,  16,  16,  16,  30,  16,  16,  16,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   2,   2,   2,   2,   2,   2,  62,   2,   2,   2,   2,   2,   2,   2,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,   2,   2,   2,   2,  62,   2,   2,  10,  10,  10,  10,  10,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0, 254,   0,   0 ,  0,   2,   2,   2,   2,  62,   2,   2,  10,  10,  10,  63,   0,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,   2,   2,   2,   2,  62,   2,   2,   2,   2,   2,   2,   2,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   2,   2,   2,  62,   2,   2,   2,   2,   2,  62,   2,   2,   2,   2,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  16,  16,  16,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  16,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  40,  40,  40,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  40,  40, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  16,  16,  16,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  16,  16, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  40,  40,  40,  40, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  40,  40, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 128, 128, 128, 128, 128, 128, 192, 128, 128, 128, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 128, 128, 128, 128, 192, 128, 128, 128, 128, 128, 128, 254,  16,  16,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0}, 
	{  0, 128, 128, 128, 128, 192, 128, 128, 128, 128, 128, 254,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   1,   0,   0}, 
	{  0, 128, 128, 128, 128, 128, 192, 128, 128, 128, 128, 128, 128, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0}, 
	{  0, 128, 128, 128, 128, 192, 128, 128, 128, 128, 192, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  64,  64,  64, 192,  64,  64,  64,  64, 192, 192, 192, 192, 254,   0,   0 ,  0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0}, 
	{  0,  64,  64,  64, 192,  64,  64,  64, 192, 192, 192, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   1,   0,   1,   0,   0}, 
	{  0,  64,  64,  64,  64, 192,  64,  64,  64,  64,  64,  64,  64, 254,   0,   0 ,  0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0}, 
	{  0, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0}, 
	{  0, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  16,  16,  16,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  16,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  40,  40,  40,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  40,  40, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  16,  16,  16,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  16,  16, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  40,  40,  40,  40, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  40,  40, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 128, 128, 128, 128, 128, 128, 192, 128, 128, 128, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 128, 128, 128, 128, 192, 128, 128, 128, 128, 128, 128, 254,  16,  16,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0}, 
	{  0, 128, 128, 128, 128, 192, 128, 128, 128, 128, 128, 254,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   1,   0,   0}, 
	{  0, 128, 128, 128, 128, 192, 128, 128, 128, 128, 128, 128, 128, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0}, 
	{  0, 128, 128, 128, 192, 128, 128, 128, 128, 128, 128, 192, 128, 128, 128,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,  64,  64,  64,  64, 192,  64,  64,  64, 192, 192, 192, 192, 254,   0,   0 ,  0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0}, 
	{  0,  64,  64,  64,  64, 192,  64,  64, 192, 192, 192, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   1,   0,   1,   0,   0}, 
	{  0,  64,  64,  64,  64, 192,  64,  64,  64,  64,  64,  64,  64, 254,   0,   0 ,  0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0}, 
	{  0, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0}, 
	{  0, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}
};

unsigned char flash HanFont3[108][32] = {
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   2,   2,   2,   2,   2,   2,   2,   2,   2,  62,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   2,   2,   2,   2,  62,   2,   2,   2,   2,  62,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   2,   2,   2,   2,   2,  62,  32,  16,  30,  48,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  32,  32,  32,  32,  32,  32,  32,  32,  32,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  32,  32,  32,  32,  50,  18,  30,  50,  34,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  32,  32,  32,   4,  60,  46,  46,  60,   4,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  34,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  42,  42,  42,  42,  42,  46,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  46,   2,   2,   2,   2,  62,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  46,  62,  34,  34,  34,  62,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  46,  62,  40,  40,  40,  62,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  46,  32,  48,  30,  48,  32,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  42,  62,  62,  42,  42,  42,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  62,  34,  62,  34,  62,  34,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  46,   4,  60,  46,  46,  60,   4,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  62,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  40,  40,  40,  40,  40,  40,  40,  40,  62,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  40,  40,  40,  62,  32,  48,  30,  48,  32,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  32,  32,  16,   8,  14,   8,  16,  32,  32,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  32,  16,  30,  16,  32,  32,  48,  30,  16,  32,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  28,  34,  34,  34,  34,  34,  34,  28,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  34,  34,  18,  10,   6,  10,  18,  34,  34,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  34,  34,  18,  10,   7,  10,  18,  34,  34,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,  62,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  42,  42,  42,  42,  42,  42,  42,  42,  42,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  34,  34,  62,  34,  34,  34,  34,  62,  34,  34,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   2,  30,  38,  34,  35,  34,  34,  38,  30,   2,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,   2,   2,   2,   2,   2,   2,   2,   2,   2,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,   2,   2,   2,   2,  62,   2,   2,   2,   2,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,   2,   2,   2,  62,  32,  32,  48,  30,  48,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  62,  32,  32,  32,  32,  32,  32,  32,  32,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  62,  32,  32,  32,  32,  34,  18,  30,  50,  34,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  62,  32,  32,  32,   4,  60,  46,  46,  60,   4,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  34,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  58,  42,  42,  42,  42,  42,  42,  42,  42,  46,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  58,  42,  42,  42,  46,   2,   2,   2,   2,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  58,  42,  42,  42,  46,  62,  34,  34,  34,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  58,  42,  42,  42,  46,  62,  40,  40,  40,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  58,  42,  42,  42,  46,  32,  48,  30,  48,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  58,  42,  42,  42,  46,  62,  42,  42,  42,  42,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  58,  42,  42,  46,  34,  62,  34,  34,  62,  34,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  58,  42,  42,  46,   4,  60,  46,  46,  60,   4,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  62,  40,  40,  40,  40,  40,  40,  40,  40,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  62,  40,  40,  40,  62,  32,  48,  30,  48,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  32,  32,  16,   8,  14,   8,  16,  32,  32,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  32,  32,  16,  30,  16,  32,  32,  48,  30,  16,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  28,  34,  34,  34,  34,  34,  34,  34,  34,  28,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  34,  34,  18,  10,   6,   6,  10,  18,  34,  34,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  36,  36,  20,  12,   6,   6,  12,  20,  36,  36,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  62,  42,  42,  42,  42,  42,  42,  42,  42,  42,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  34,  34,  62,  34,  34,  34,  34,  62,  34,  34,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,   2,  30,  38,  34,  35,  34,  34,  38,  30,   2,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   2,   2,   2,   2,   2,  62,   2,   2,   2,   2,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   2,   2,   2,   2,   2,  62,  32,  48,  30,  48,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  32,  32,  32,  32,  32,  34,  50,  30,  50,  34,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  32,  32,  32,  36,  60,  44,  46,  44,  60,   4,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  42,  42,  42,  42,  42,  42,  46,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  42,  46,   2,   2,   2,   2,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  42,  46,  62,  34,  34,  34,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  42,  62,  62,  40,  40,  40,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  42,  46,  32,  48,  30,  48,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  42,  62,  62,  42,  42,  42,  42,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  46,  34,  62,  34,  34,  62,  34,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  46,   4,  60,  46,  46,  60,   4,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  34,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  40,  40,  40,  40,  40,  40,  40,  40,  40,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  40,  40,  40,  40,  62,  32,  48,  30,  48,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  32,  32,  16,  16,   8,  14,   8,  16,  16,  32,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  32,  16,  30,  16,  48,  32,  32,  48,  30,  16,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  28,  34,  34,  34,  34,  34,  34,  34,  34,  34,  28,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  34,  34,  18,  18,  10,   6,  10,  18,  18,  34,  34,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  36,  36,  20,  20,  12,   6,  12,  20,  20,  36,  36,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  34,  34,  62,  34,  34,  34,  34,  34,  62,  34,  34,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   4,  60,  36,  36,  36,  38,  36,  36,  36,  60,   4,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   2,   2,   2,   2,   2,  62,   2,   2,   2,   2,   2,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   2,   2,   2,   2,   2,  62,  32,  32,  48,  30,  48,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  62,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  62,  32,  32,  32,  32,  32,  32,  34,  50,  30,  50,  34,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  62,  32,  32,  32,  32,   4,  60,  46,  46,  46,  60,   4,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  58,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  46,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  58,  42,  42,  42,  42,  46,   2,   2,   2,   2,   2,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  58,  42,  42,  42,  46,   0,  62,  34,  34,  34,  34,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  58,  42,  42,  42,  46,   0,  62,  40,  40,  40,  40,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  58,  42,  42,  42,  42,  46,  32,  32,  48,  30,  48,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  58,  42,  42,  42,  42,  46,   0,  62,  42,  42,  42,  42,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  58,  42,  42,  42,  46,  34,  62,  34,  34,  34,  62,  34,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  58,  42,  42,  42,  42,  46,   4,  60,  36,  38,  36,  60,   4,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  62,  40,  40,  40,  40,  40,  40,  40,  40,  40,  40,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  62,  40,  40,  40,  40,  62,  32,  32,  48,  30,  48,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  32,  32,  16,  16,   8,  14,   8,  16,  16,  32,  32,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  32,  16,  30,  16,  48,  32,  32,  48,  16,  30,  16,  32,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  28,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,  28,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  34,  34,  18,  18,  10,   6,  10,  18,  18,  34,  34,  34,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  36,  36,  20,  20,  12,   6,  12,  20,  20,  36,  36,  36,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  62,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  62,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  34,  34,  62,  34,  34,  34,  34,  34,  34,  62,  34,  34,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   4,  60,  36,  36,  36,  38,  36,  36,  36,  36,  60,   4,   0,   0}
};
// ϼ ->  ȯ ̺
unsigned flash Conv_Tbl[2354] =
unsigned flash Conv_Tbl[2354] =
{
	    34913u,34914u,34917u,34920u,34921u,34922u,34923u,34929u,34931u,34932u,
	    34933u,34934u,34935u,34936u,34937u,34939u,34940u,34941u,34945u,34946u,
	    34949u,34953u,34961u,34963u,34965u,34966u,34967u,34977u,34978u,34981u,
	    34985u,34997u,34999u,35009u,35013u,35017u,35041u,35042u,35045u,35048u,
	    35049u,35051u,35057u,35059u,35061u,35062u,35063u,35064u,35067u,35068u,
	    35069u,35137u,35141u,35145u,35153u,35155u,35157u,35158u,35159u,35169u,
	    35170u,35171u,35173u,35176u,35177u,35185u,35187u,35189u,35190u,35191u,
	    35195u,35201u,35205u,35209u,35219u,35221u,35233u,35234u,35237u,35240u,
	    35241u,35243u,35245u,35248u,35249u,35251u,35253u,35255u,35256u,35265u,
	    35266u,35269u,35273u,35275u,
	    35281u,35283u,35285u,35287u,35297u,35301u,35305u,35313u,35318u,35319u,
	    35393u,35394u,35397u,35401u,35409u,35411u,35413u,35415u,35425u,35429u,
	    35433u,35443u,35445u,35457u,35458u,35461u,35464u,35465u,35466u,35467u,
	    35472u,35473u,35475u,35477u,35479u,35480u,35489u,35490u,35493u,35497u,
	    35510u,35511u,35521u,35541u,35553u,35554u,35557u,35561u,35569u,35571u,
	    35573u,35649u,35653u,35657u,35681u,35682u,35685u,35688u,35689u,35690u,
	    35697u,35699u,35701u,35703u,35713u,35745u,35746u,35749u,35752u,35753u,
	    35755u,35761u,35763u,35765u,35767u,35768u,35772u,35937u,35938u,35939u,
	    35941u,35945u,35947u,35953u,35955u,35957u,35958u,35959u,35963u,35969u,
	    35970u,35973u,35977u,35985u,
	    35987u,35989u,35990u,35991u,36001u,36002u,36009u,36065u,36066u,36067u,
	    36069u,36073u,36081u,36083u,36085u,36086u,36087u,36161u,36162u,36165u,
	    36177u,36181u,36183u,36193u,36197u,36201u,36213u,36214u,36219u,36225u,
	    36257u,36258u,36261u,36263u,36265u,36273u,36275u,36277u,36279u,36280u,
	    36281u,36289u,36290u,36297u,36297u,36311u,36321u,36322u,36343u,36417u,
	    36421u,36425u,36433u,36435u,36439u,36449u,36481u,36482u,36485u,36489u,
	    36496u,36497u,36499u,36501u,36503u,36504u,36513u,36521u,36534u,36535u,
	    36545u,36546u,36549u,36553u,36561u,36563u,36566u,36577u,36581u,36585u,
	    36593u,36595u,36673u,36705u,36706u,36709u,36711u,36713u,36715u,36720u,
	    36721u,36723u,36725u,36727u,
	    36731u,36769u,36770u,36773u,36777u,36785u,36787u,36789u,36791u,36961u,
	    36962u,36963u,36965u,36968u,36969u,36970u,36971u,36977u,36979u,36981u,
	    36982u,36983u,36984u,36985u,36987u,36989u,36993u,36994u,36997u,37001u,
	    37009u,37011u,37013u,37014u,37015u,37025u,37026u,37029u,37033u,37041u,
	    37047u,37089u,37090u,37092u,37093u,37097u,37099u,37100u,37105u,37107u,
	    37109u,37110u,37111u,37117u,37185u,37186u,37189u,37193u,37201u,37203u,
	    37205u,37206u,37207u,37217u,37218u,37221u,37225u,37233u,37235u,37238u,
	    37239u,37242u,37249u,37253u,37281u,37282u,37285u,37289u,37291u,37297u,
	    37299u,37301u,37303u,37308u,37309u,37313u,37317u,37321u,37334u,37441u,
	    37445u,37449u,37457u,37459u,
	    37461u,37473u,37474u,37477u,37481u,37491u,37493u,37495u,37505u,37506u,
	    37509u,37512u,37513u,37521u,37523u,37525u,37527u,37537u,37558u,37569u,
	    37601u,37605u,37609u,37617u,37619u,37697u,37698u,37705u,37713u,37715u,
	    37719u,37729u,37730u,37733u,37737u,37738u,37739u,37745u,37747u,37749u,
	    37751u,37752u,37756u,37761u,37765u,37769u,37793u,37794u,37797u,37801u,
	    37801u,37809u,37811u,37813u,37815u,37820u,37985u,37986u,37987u,37989u,
	    37992u,37993u,37994u,37995u,37996u,38000u,38001u,38003u,38005u,38006u,
	    38007u,38008u,38009u,38013u,38017u,38018u,38021u,38025u,38033u,38035u,
	    38037u,38038u,38039u,38049u,38113u,38114u,38115u,38117u,38120u,38121u,
	    38123u,38124u,38129u,38131u,
	    38133u,38135u,38137u,38140u,38209u,38210u,38213u,38217u,38225u,38227u,
	    38229u,38230u,38231u,38241u,38245u,38249u,38262u,38263u,38273u,38277u,
	    38305u,38306u,38309u,38312u,38313u,38315u,38317u,38321u,38323u,38325u,
	    38327u,38329u,38331u,38337u,38341u,38345u,38369u,38390u,38465u,38469u,
	    38473u,38481u,38483u,38485u,38497u,38529u,38530u,38533u,38537u,38545u,
	    38547u,38549u,38551u,38561u,38582u,38593u,38615u,38625u,38629u,38633u,
	    38643u,38645u,38647u,38721u,38725u,38729u,38737u,38743u,38753u,38754u,
	    38757u,38760u,38761u,38763u,38769u,38771u,38773u,38775u,38785u,38817u,
	    38818u,38821u,38824u,38825u,38833u,38835u,38837u,38838u,38839u,38840u,
	    39009u,39010u,39013u,39017u,
	    39025u,39027u,39029u,39030u,39031u,39037u,39041u,39042u,39045u,39049u,
	    39057u,39059u,39061u,39062u,39063u,39137u,39138u,39141u,39145u,39147u,
	    39148u,39153u,39155u,39157u,39158u,39159u,39165u,39233u,39234u,39237u,
	    39241u,39249u,39251u,39253u,39254u,39255u,39265u,39286u,39329u,39330u,
	    39333u,39337u,39351u,39361u,39369u,39393u,39489u,39493u,39553u,39554u,
	    39557u,39561u,39568u,39569u,39575u,39617u,39649u,39653u,39657u,39665u,
	    39667u,39671u,39777u,39778u,39781u,39784u,39785u,39793u,39795u,39797u,
	    39809u,39813u,39817u,39825u,39827u,39841u,39845u,39849u,39857u,39859u,
	    39861u,39863u,40033u,40034u,40037u,40041u,40049u,40051u,40053u,40054u,
	    40055u,40056u,40060u,40061u,
	    40065u,40066u,40069u,40073u,40081u,40083u,40085u,40086u,40087u,40097u,
	    40098u,40101u,40117u,40119u,40161u,40162u,40165u,40169u,40177u,40179u,
	    40181u,40182u,40183u,40189u,40257u,40258u,40261u,40265u,40273u,40275u,
	    40277u,40279u,40289u,40290u,40293u,40297u,40305u,40307u,40309u,40310u,
	    40311u,40321u,40325u,40339u,40341u,40353u,40354u,40357u,40361u,40369u,
	    40371u,40373u,40375u,40385u,40389u,40407u,40438u,40513u,40517u,40521u,
	    40529u,40531u,40533u,40535u,40545u,40549u,40553u,40563u,40565u,40567u,
	    40577u,40578u,40581u,40585u,40593u,40595u,40597u,40599u,40609u,40630u,
	    40641u,40673u,40674u,40677u,40681u,40689u,40693u,40695u,40769u,40770u,
	    40773u,40777u,40785u,40787u,
	    40789u,40791u,40801u,40802u,40805u,40809u,40817u,40819u,40821u,40823u,
	    40824u,40827u,40828u,40865u,40866u,40869u,40873u,40881u,40883u,40885u,
	    40887u,41057u,41058u,41061u,41063u,41064u,41065u,41066u,41067u,41073u,
	    41075u,41077u,41079u,41080u,41083u,41085u,41089u,41090u,41093u,41097u,
	    41105u,41107u,41109u,41110u,41111u,41112u,41121u,41122u,41129u,41143u,
	    41185u,41186u,41189u,41193u,41195u,41201u,41203u,41205u,41207u,41208u,
	    41213u,41281u,41282u,41285u,41289u,41297u,41299u,41301u,41302u,41303u,
	    41313u,41314u,41317u,41321u,41333u,41334u,41335u,41337u,41345u,41377u,
	    41378u,41380u,41381u,41385u,41387u,41393u,41395u,41397u,41399u,41409u,
	    41413u,41430u,41431u,41537u,
	    41541u,41545u,41555u,41557u,41559u,41569u,41573u,41577u,41587u,41589u,
	    41601u,41602u,41603u,41605u,41608u,41609u,41610u,41611u,41617u,41619u,
	    41621u,41623u,41627u,41629u,41633u,41637u,41641u,41651u,41653u,41665u,
	    41697u,41701u,41705u,41793u,41797u,41801u,41809u,41813u,41825u,41829u,
	    41833u,41841u,41845u,41889u,41890u,41893u,41896u,41897u,41899u,41905u,
	    41907u,41909u,41910u,41911u,41913u,41915u,42081u,42082u,42083u,42084u,
	    42085u,42088u,42089u,42090u,42091u,42092u,42097u,42099u,42101u,42103u,
	    42107u,42113u,42114u,42117u,42121u,42129u,42131u,42133u,42134u,42135u,
	    42139u,42145u,42146u,42149u,42163u,42209u,42210u,42213u,42216u,42217u,
	    42219u,42225u,42227u,42229u,
	    42231u,42232u,42305u,42306u,42309u,42312u,42313u,42321u,42323u,42325u,
	    42326u,42327u,42337u,42338u,42341u,42345u,42355u,42357u,42358u,42359u,
	    42363u,42369u,42373u,42401u,42402u,42403u,42405u,42409u,42417u,42419u,
	    42421u,42423u,42433u,42437u,42454u,42465u,42486u,42561u,42562u,42565u,
	    42569u,42577u,42579u,42593u,42597u,42625u,42626u,42629u,42632u,42633u,
	    42634u,42635u,42641u,42643u,42645u,42647u,42651u,42652u,42657u,42665u,
	    42678u,42689u,42721u,42722u,42725u,42729u,42743u,42817u,42821u,42825u,
	    42833u,42837u,42839u,42849u,42850u,42853u,42857u,42865u,42867u,42869u,
	    42913u,42914u,42917u,42921u,42923u,42929u,42931u,42933u,42935u,42936u,
	    42937u,43105u,43106u,43109u,
	    43113u,43115u,43121u,43123u,43125u,43126u,43127u,43133u,43137u,43138u,
	    43141u,43145u,43153u,43155u,43157u,43158u,43159u,43169u,43170u,43185u,
	    43233u,43234u,43237u,43240u,43241u,43249u,43253u,43254u,43255u,43329u,
	    43351u,43361u,43362u,43377u,43379u,43381u,43382u,43383u,43425u,43426u,
	    43429u,43433u,43441u,43443u,43447u,43585u,43617u,43639u,43649u,43650u,
	    43653u,43657u,43665u,43669u,43671u,43841u,43863u,43873u,43877u,43881u,
	    43889u,43891u,43937u,43938u,43941u,43945u,43953u,43955u,43957u,43959u,
	    44129u,44130u,44132u,44133u,44136u,44137u,44138u,44139u,44145u,44147u,
	    44149u,44150u,44151u,44155u,44161u,44162u,44165u,44169u,44177u,44179u,
	    44181u,44182u,44183u,44193u,
	    44194u,44197u,44201u,44209u,44211u,44213u,44215u,44225u,44229u,44233u,
	    44241u,44247u,44257u,44258u,44259u,44260u,44261u,44264u,44265u,44267u,
	    44268u,44273u,44275u,44277u,44278u,44279u,44284u,44353u,44354u,44357u,
	    44361u,44369u,44371u,44373u,44374u,44375u,44385u,44386u,44389u,44393u,
	    44401u,44403u,44405u,44406u,44407u,44417u,44421u,44425u,44439u,44449u,
	    44450u,44451u,44453u,44457u,44459u,44465u,44467u,44469u,44471u,44475u,
	    44481u,44482u,44485u,44489u,44503u,44513u,44517u,44521u,44529u,44533u,
	    44534u,44609u,44613u,44617u,44625u,44627u,44629u,44641u,44642u,44645u,
	    44649u,44657u,44659u,44661u,44663u,44673u,44674u,44677u,44680u,44681u,
	    44689u,44691u,44693u,44695u,
	    44697u,44699u,44700u,44705u,44726u,44737u,44738u,44741u,44745u,44753u,
	    44759u,44769u,44770u,44773u,44777u,44785u,44787u,44789u,44791u,44865u,
	    44866u,44873u,44881u,44885u,44887u,44897u,44898u,44901u,44905u,44906u,
	    44913u,44915u,44917u,44919u,44961u,44962u,44965u,44968u,44969u,44976u,
	    44977u,44979u,44981u,44983u,44988u,45153u,45154u,45156u,45157u,45161u,
	    45169u,45171u,45174u,45175u,45181u,45185u,45186u,45189u,45193u,45201u,
	    45203u,45206u,45207u,45239u,45281u,45282u,45285u,45289u,45291u,45297u,
	    45299u,45302u,45303u,45377u,45381u,45385u,45385u,45473u,45474u,45477u,
	    45480u,45481u,45483u,45489u,45491u,45495u,45505u,45506u,45509u,45526u,
	    45537u,45558u,45633u,45637u,
	    45641u,45649u,45651u,45665u,45697u,45698u,45701u,45705u,45713u,45715u,
	    45719u,45729u,45750u,45761u,45793u,45797u,45911u,45921u,45922u,45925u,
	    45929u,45931u,45936u,45937u,45939u,45953u,45957u,45961u,45969u,45985u,
	    45986u,45989u,45993u,46001u,46003u,46005u,46007u,46177u,46178u,46181u,
	    46182u,46183u,46185u,46186u,46187u,46192u,46193u,46195u,46197u,46198u,
	    46199u,46203u,46204u,46209u,46210u,46213u,46217u,46225u,46227u,46229u,
	    46230u,46231u,46241u,46242u,46245u,46249u,46252u,46257u,46259u,46261u,
	    46263u,46267u,46269u,46273u,46277u,46281u,46291u,46305u,46306u,46309u,
	    46310u,46312u,46313u,46314u,46315u,46321u,46323u,46324u,46325u,46326u,
	    46327u,46328u,46330u,46332u,
	    46401u,46402u,46405u,46409u,46417u,46419u,46421u,46423u,46433u,46434u,
	    46435u,46437u,46441u,46443u,46444u,46449u,46451u,46452u,46453u,46454u,
	    46455u,46459u,46460u,46461u,46465u,46469u,46473u,46481u,46483u,46485u,
	    46486u,46497u,46498u,46501u,46505u,46506u,46507u,46509u,46512u,46513u,
	    46515u,46517u,46519u,46521u,46529u,46530u,46533u,46537u,46545u,46547u,
	    46549u,46550u,46551u,46561u,46562u,46565u,46577u,46581u,46583u,46657u,
	    46658u,46661u,46665u,46673u,46675u,46677u,46679u,46689u,46690u,46693u,
	    46697u,46705u,46707u,46709u,46711u,46721u,46722u,46725u,46729u,46730u,
	    46731u,46737u,46739u,46741u,46743u,46753u,46754u,46757u,46761u,46769u,
	    46771u,46774u,46775u,46785u,
	    46786u,46789u,46793u,46801u,46803u,46807u,46817u,46818u,46821u,46825u,
	    46833u,46835u,46837u,46839u,46913u,46914u,46917u,46921u,46929u,46931u,
	    46933u,46935u,46937u,46945u,46946u,46949u,46953u,46959u,46961u,46963u,
	    46965u,46967u,46968u,46969u,46970u,46971u,46972u,46973u,46977u,46981u,
	    46985u,46993u,46997u,47009u,47010u,47013u,47017u,47018u,47019u,47024u,
	    47025u,47027u,47029u,47030u,47031u,47032u,47036u,47201u,47202u,47205u,
	    47207u,47208u,47209u,47211u,47217u,47219u,47221u,47222u,47223u,47224u,
	    47233u,47234u,47237u,47241u,47249u,47251u,47253u,47254u,47255u,47265u,
	    47266u,47269u,47271u,47273u,47281u,47287u,47297u,47301u,47305u,47329u,
	    47330u,47333u,47337u,47339u,
	    47345u,47347u,47349u,47351u,47352u,47425u,47426u,47429u,47433u,47441u,
	    47443u,47445u,47447u,47457u,47461u,47465u,47473u,47475u,47478u,47479u,
	    47489u,47521u,47522u,47525u,47529u,47531u,47537u,47539u,47541u,47543u,
	    47544u,47545u,47549u,47553u,47554u,47561u,47571u,47573u,47575u,47585u,
	    47606u,47607u,47681u,47685u,47689u,47697u,47699u,47701u,47703u,47713u,
	    47714u,47717u,47735u,47745u,47746u,47749u,47753u,47754u,47755u,47761u,
	    47763u,47765u,47767u,47777u,47798u,47809u,47841u,47842u,47845u,47849u,
	    47857u,47859u,47861u,47937u,47941u,47945u,47953u,47969u,47970u,47973u,
	    47977u,47985u,47987u,47989u,47991u,48033u,48034u,48037u,48040u,48041u,
	    48043u,48049u,48051u,48053u,
	    48055u,48056u,48059u,48060u,48225u,48226u,48229u,48231u,48233u,48236u,
	    48241u,48243u,48245u,48246u,48247u,48257u,48258u,48261u,48265u,48273u,
	    48275u,48277u,48278u,48279u,48289u,48293u,48311u,48353u,48354u,48357u,
	    48361u,48369u,48371u,48373u,48374u,48375u,48449u,48471u,48481u,48502u,
	    48545u,48546u,48549u,48553u,48561u,48563u,48565u,48567u,48569u,48577u,
	    48578u,48585u,48598u,48609u,48630u,48705u,48709u,48713u,48721u,48723u,
	    48759u,48769u,48770u,48773u,48777u,48785u,48787u,48791u,48801u,48822u,
	    48823u,48865u,48961u,48993u,49009u,49013u,49015u,49057u,49058u,49061u,
	    49065u,49073u,49075u,49079u,49080u,49085u,49249u,49250u,49253u,49255u,
	    49257u,49265u,49267u,49269u,
	    49270u,49271u,49272u,49281u,49282u,49285u,49289u,49297u,49299u,49301u,
	    49302u,49303u,49313u,49317u,49319u,49321u,49329u,49335u,49377u,49378u,
	    49381u,49385u,49393u,49395u,49397u,49398u,49399u,49473u,49474u,49477u,
	    49481u,49489u,49491u,49493u,49495u,49505u,49509u,49526u,49537u,49541u,
	    49559u,49569u,49570u,49573u,49577u,49585u,49587u,49589u,49591u,49601u,
	    49605u,49609u,49623u,49729u,49733u,49737u,49745u,49747u,49749u,49751u,
	    49761u,49777u,49793u,49794u,49797u,49801u,49809u,49811u,49813u,49815u,
	    49825u,49846u,49857u,49861u,49889u,49893u,49897u,49905u,49907u,49909u,
	    49911u,49985u,49989u,49993u,50001u,50007u,50017u,50018u,50021u,50025u,
	    50033u,50035u,50037u,50039u,
	    50081u,50082u,50085u,50088u,50089u,50090u,50097u,50099u,50101u,50103u,
	    50273u,50274u,50277u,50281u,50289u,50291u,50293u,50295u,50305u,50306u,
	    50309u,50313u,50321u,50323u,50325u,50326u,50327u,50337u,50338u,50359u,
	    50401u,50402u,50405u,50408u,50409u,50417u,50419u,50421u,50422u,50423u,
	    50497u,50498u,50501u,50505u,50513u,50515u,50517u,50519u,50529u,50533u,
	    50537u,50545u,50547u,50549u,50550u,50551u,50561u,50593u,50594u,50597u,
	    50601u,50609u,50611u,50613u,50615u,50625u,50626u,50629u,50633u,50641u,
	    50647u,50657u,50679u,50753u,50761u,50785u,50817u,50818u,50821u,50825u,
	    50833u,50835u,50837u,50839u,50849u,50853u,50857u,50871u,50881u,50903u,
	    50913u,50914u,50917u,50921u,
	    50929u,50931u,50933u,50935u,51009u,51013u,51017u,51025u,51041u,51042u,
	    51045u,51049u,51057u,51059u,51063u,51105u,51106u,51109u,51113u,51121u,
	    51123u,51125u,51127u,51297u,51298u,51301u,51305u,51306u,51313u,51315u,
	    51317u,51318u,51319u,51329u,51330u,51333u,51337u,51345u,51347u,51349u,
	    51350u,51351u,51361u,51383u,51425u,51426u,51429u,51433u,51435u,51441u,
	    51443u,51445u,51446u,51447u,51521u,51522u,51525u,51529u,51537u,51539u,
	    51541u,51543u,51553u,51557u,51574u,51585u,51589u,51617u,51618u,51621u,
	    51625u,51633u,51635u,51637u,51639u,51644u,51649u,51653u,51681u,51777u,
	    51781u,51797u,51799u,51809u,51841u,51842u,51845u,51849u,51857u,51859u,
	    51861u,51863u,51873u,51894u,
	    51905u,51937u,51938u,51941u,51945u,51953u,51955u,51959u,52033u,52037u,
	    52041u,52049u,52055u,52065u,52066u,52069u,52072u,52073u,52075u,52081u,
	    52083u,52085u,52097u,52101u,52105u,52113u,52115u,52129u,52130u,52133u,
	    52137u,52145u,52147u,52149u,52151u,52321u,52322u,52323u,52325u,52329u,
	    52331u,52337u,52339u,52341u,52342u,52343u,52347u,52353u,52354u,52357u,
	    52361u,52369u,52371u,52373u,52374u,52375u,52385u,52386u,52449u,52450u,
	    52453u,52457u,52465u,52467u,52469u,52470u,52471u,52545u,52546u,52549u,
	    52553u,52561u,52563u,52565u,52567u,52577u,52581u,52585u,52593u,52595u,
	    52598u,52599u,52609u,52617u,52627u,52629u,52641u,52642u,52645u,52649u,
	    52657u,52659u,52661u,52663u,
	    52673u,52695u,52801u,52805u,52833u,52837u,52841u,52851u,52853u,52865u,
	    52866u,52869u,52872u,52873u,52875u,52881u,52883u,52885u,52887u,52897u,
	    52919u,52961u,52965u,52969u,52977u,52981u,53057u,53061u,53065u,53073u,
	    53077u,53079u,53089u,53093u,53097u,53105u,53107u,53109u,53153u,53154u,
	    53157u,53161u,53169u,53171u,53173u,53175u,53345u,53346u,53349u,53353u,
	    53358u,53361u,53363u,53365u,53367u,53377u,53378u,53381u,53385u,53393u,
	    53395u,53397u,53398u,53399u,53409u,53431u,53473u,53474u,53477u,53481u,
	    53483u,53489u,53491u,53493u,53495u,53569u,53570u,53573u,53577u,53585u,
	    53587u,53589u,53591u,53601u,53602u,53605u,53609u,53617u,53619u,53621u,
	    53622u,53623u,53633u,53637u,
	    53641u,53651u,53665u,53666u,53669u,53673u,53678u,53681u,53683u,53685u,
	    53687u,53691u,53697u,53698u,53701u,53705u,53717u,53719u,53729u,53730u,
	    53733u,53749u,53751u,53825u,53826u,53829u,53833u,54195u,53845u,53847u,
	    53857u,53861u,53865u,53875u,53877u,53889u,53890u,53893u,53897u,53902u,
	    53905u,53909u,53911u,53921u,53925u,53929u,53937u,53943u,53953u,53954u,
	    53957u,53961u,53975u,53985u,53986u,53989u,53993u,54001u,54003u,54005u,
	    54007u,54081u,54082u,54085u,54089u,54097u,54101u,54103u,54113u,54114u,
	    54117u,54119u,54120u,54121u,54122u,54129u,54131u,54133u,54135u,54139u,
	    54145u,54149u,54153u,54161u,54163u,54167u,54177u,54178u,54181u,54185u,
	    54193u,54195u,54197u,54199u
};


//  

// LCD  


// Լ 
void Clrscr(void);						// ü ȭ 
void Cleardevice(void);						// ü ȭ 
void Gotoxy(int x,int y);					// ׷ ǥ 
void Gotoxyt(int x,int y);					// ؽƮ ǥ 

void Setcolor(char color);					// ڻ (_WHITE,_BLACK)
void Backlight_Ctrl(char sts);					// LCD BACKlight ON/OFF

void Putch(unsigned c); 					// ڸ 
void Putchxy(int x,int y,unsigned c);				// ׷ ǥ  
void Putchxyt(int x,int y,unsigned c);				// ؽƮ ǥ  

void Puts(const char *str);					// ڿ 
void Putsxy(int x,int y,const char *str);			// ׷ ǥ ڿ 
void Putsxyt(int x,int y,const char *str);			// ؽƮ ǥ ڿ 

void Puts_f(const char flash *str);				// CODE ڿ 
void Putsxy_f(int x,int y,const char flash *str);		// ׷ ǥ CODE ڿ 
void Putsxyt_f(int x,int y,const char flash *str);		// ؽƮ ǥ CODE ڿ 

void Line(int x1,int y1,int x2,int y2);				// ׷ǥ  ׸
void Rectangle(int x1,int y1,int x2,int y2);			// ׷ ǥ ڽ ׸
void Rectanglefill(int x1,int y1,int x2,int y2);		// ä ڽ ׸
void Circle(int xx,int yy,int radius);				//  ׸
void Ellipse(int xx,int yy,int a0,int b0);			// Ÿ ׸

void Putpixel(int x,int y,char color);				// ȭ鿡  (,,÷(_WHITE,BLACK))
void Putpixelb(int x,int y,unsigned char datac,char color);	// ȭ鿡 Ʈ 

void symmetry4(int xx,int yy,int x,int y);
void _Plotcircle(int xx,int yy,int x,int y);

void _Putch(unsigned int c);					// 1Ʈ  
void *_GetHanImage(unsigned c);					// ѱ Ʈ ε
void _memor(unsigned char *s1,unsigned char flash *s2, int len);// ѱ Ʈ 
unsigned char* _GetAscImage(int c);		        	//  Ʈ  ε
void Han_Conv(char *buf);					// ϼ(SRAM)  (SRAM) ȯ
void Han_Conv_f(char flash *buf);				// ϼ(FLASH) (SRAM) ȯ

// LCD H/W 
void GLCD_Init(void);						// GLCD Init
void GLCD_Busy(void);						// LCD Busy Check
void GLCD_Command(unsigned char uch);				// COMMAND Write
void GLCD_Dwrite(unsigned char uch);				// DATA Write
unsigned char GLCD_Dread(void);					// DATA 

//  
int _screen_color = 15;					// ڻ 
int _screen_curx = 0;						// X ǥ 
int _screen_cury = 0;						// Yǥ 

static unsigned char ib[32];					// ѱ  
static unsigned char ascii_fbuf[20];                            //    
static unsigned char han_conv_buf[101];				// ѱ    

// =============================== LCD ȭ  ===============================
// [μ] void
// [] 128*64
// -----------------------------------------------------------------------------
void Clrscr(void)
{
	Cleardevice();						// ȭ 
}

// =============================== LCD ȭ  ===============================
// [μ] void
// [] 128*64
// -----------------------------------------------------------------------------
void Cleardevice(void)
{
int i,page,col;
	
	DDRA = 0xff;						// LCD_D[0..7] OUTPUT Mode Set
	for(page = 0; page < 8; page++){			// Page0-7
		GLCD_Command(0xB0				+page);		// page set
		GLCD_Command(0x10				);		// Column set
		GLCD_Command(0x00				);

		PORTA = 0x00;					// Clear Data		
		PORTC &= ~0x01;					// PORTC.0 = LCD_CS1 = 0
		PORTE &= ~0x10;					// PORTE.4 :: LCD_E = 0
		PORTE |= 0x20;					// PORTE.5 :: LCD RS = 1 :: Data Set
		(*(unsigned char *) 0x65) &= ~0x01;					// PORTG.0 :: LCD_R/W\ = Write	
		for(col = 0; col < 128; col++){			// column0-127
			PORTE |= 0x10;				// PORTE.4 :: LCD_E = 1
			for(i = 0; i < 2; i++);			// ð 
			PORTE &= ~0x10;				// PORTE.4 :: LCD_E = 0
			for(i = 0; i < 2; i++);			// ð 
		} 
		PORTC |= 0x01;					// PORTC.0 = LCD_CS1 = 1
	}
	_screen_curx = _screen_cury = 0;
}

// ============================= ׷ ǥ  ==============================
// [μ] int x,int y
// Item1: x pos(0 - 127)
// Item2: y pos(0 - 63)
// -----------------------------------------------------------------------------
void Gotoxy(int x,int y)
{
	if(x >= 0 && x < 128){					// X ʰ ˻
		if(y >= 0 && y < 64){				// Y ʰ ˻
			_screen_curx = x;
			_screen_cury = y;
		}
	}
}

// ======================= ȭ鿡 ؽƮ ǥ  ===========================
// [μ] int x,int y
// Item1  x pos(1 - 16)
// Item2  y pos(1 - 4)
// [] _screen_curx,_screen_cury
// -----------------------------------------------------------------------------
void Gotoxyt(int x,int y)
{
int x1 = (x-1) * 8,y1;

	y1 = (y-1) * 16;
	if(x1 >= 0 && x1 < 128){
		if(y1 >= 0 && y1 < 64){
			_screen_curx = x1;
			_screen_cury = y1;
		}
	}
}

// =============================== ڻ  ===============================
// [μ] char color
// Item1: ڻ(_WHITE,_BLACK)
// -----------------------------------------------------------------------------
void Setcolor(char color)
{
	_screen_color = color;					// ڻ 
}

// =============================== ڻ  ===============================
// [μ] char color
// Item1: 0(off),1(on)
// -----------------------------------------------------------------------------
void Backlight_Ctrl(char sts)
{
	if(sts == 0) PORTC &= ~0x02;				// BackLight off
	else PORTC |= 0x02;					// BackLight on
}

// ============================== ѹڸ  Ѵ. ==========================
// [μ] unsigned c
// Item1:  (ѱ ڵ )
// -----------------------------------------------------------------------------
void Putch(unsigned c)
{
	_Putch(c&0xff);						// 1Ʈ ڸ ǥ
}

// ================  ׷ ǥ ѹڸ  Ѵ. ===================
// [μ] int x
//	  int y
//	  unsigned c
// Item1:    ġ(0 - 127)
// Item2:    ġ(0 - 63)
// Item3:  ((ѱ ڵ )
// -----------------------------------------------------------------------------
void Putchxy(int x,int y,unsigned c)
{
	Gotoxy(x,y);						// Base Cursor Point Set
	Putch(c);						// 1Ʈ ڸ ǥ
}

// ===================  ؽƮ ǥ ѹڸ  Ѵ. ================
//  [μ] int x
//	   int y
//	   unsigned c
//  Item1:    ġ(1 - 16)
//  Item2:    ġ(1 - 4)
//  Item3:  (ѱ ڵ )
// -----------------------------------------------------------------------------
void Putchxyt(int x,int y,unsigned c)
{
	Gotoxyt(x,y);						// Base Cursor Point Set
	Putch(c);						// 1Ʈ ڸ ǥ
}

// ====================  Ŀ ġ  ڿ  Ѵ. ==================
//  [μ] const char *str
//  Item1:  ڿ(ѿ)
// -----------------------------------------------------------------------------
void Puts(const char *str)
{
unsigned char byte1st = 0,c;
unsigned datau,i = 0;

	Han_Conv((char*)str);					// ϼ  ȯ
	while((c = han_conv_buf[i++]) != 0){			// ҽ Han_Conv() 
//	while((c = *str++) != 0){				// 쿡 ϼ->  
		if(byte1st){
			datau = ((unsigned)byte1st << 8) | (unsigned)c;
			_Putch(datau);				// ѱ ڸ ǥ
			byte1st = 0;                    	
		}                                       	
		else if(c & 0x80){                      	
			byte1st = c;				// ѱ Ÿ 
		}                                       	
		else{                                   	
			if(c == 0x0a){				//  ǵ
				_Putch(0x0d);           	
				_Putch(0x0a);           	
			}                               	
			else _Putch(c); 			//  ڸ ǥ
		}
	}
}

// ================  Ŀ ġ  FLASH ڿ  Ѵ. ================
//  [μ] const char *str
//  Item1:  ڿ FLASH(ѿ)
// -----------------------------------------------------------------------------
void Puts_f(const char flash *str)
{
unsigned char byte1st = 0,c;
unsigned datau,i = 0;

	Han_Conv_f((char flash*)str);				// ϼ  ȯ
	while((c = han_conv_buf[i++]) != 0){			// ҽ Han_Conv() 
//	while((c = *str++) != 0){				// 쿡 ϼ->  
		if(byte1st){
			datau = ((unsigned)byte1st << 8) | (unsigned)c;
			_Putch(datau);				// ѱ ڸ ǥ
			byte1st = 0;                    	
		}                                       	
		else if(c & 0x80){                      	
			byte1st = c;				// ѱ Ÿ 
		}                                       	
		else{                                   	
			if(c == 0x0a){				//  ǵ
				_Putch(0x0d);           	
				_Putch(0x0a);           	
			}                               	
			else _Putch(c); 			//  ڸ ǥ
		}
	}
}

// ==================  ׷ ġ  ڿ  Ѵ. ==================
//  [μ] int x
//	   int x
//	   const char *str
//  Item1: Ŀ  ǥ(0 - 127)
//  Item2: Ŀ  ǥ(0 - 63)
//  Item3:  ڿ(ѿ)
// -----------------------------------------------------------------------------
void Putsxy(int x,int y,const char *str)
{
	Gotoxy(x,y);						// Ŀ ġ 
	Puts(str);						// ڿ ǥ
}

// ================  ׷ ġ FLASH ڿ  Ѵ. ===============
//  [μ] int x
//	   int x
//	   const char flash *str
//  Item1: Ŀ  ǥ(0 - 127)
//  Item2: Ŀ  ǥ(0 - 63)
//  Item3:  ڿ FLASH(ѿ)
// -----------------------------------------------------------------------------
void Putsxy_f(int x,int y,const char flash *str)
{
	Gotoxy(x,y);						// Ŀ ġ 
	Puts_f(str);						// ڿ ǥ
}

// ================  ؽƮ ġ  ڿ  Ѵ. ====================
//  [μ] int x
//	   int y
//	   const char *str
//  Item1: Ŀ  ǥ(1 - 16)
//  Item2: Ŀ  ǥ(1 - 4)
//  Item3:  ڿ(ѿ)
// -----------------------------------------------------------------------------
void Putsxyt(int x,int y,const char *str)
{
	Gotoxyt(x,y);						// Ŀ ġ 
	Puts(str);						// ڿ ǥ
}

// ===============  ؽƮ ġ FLASH ڿ  Ѵ. ================
//  [μ] int x
//	   int y
//	   const char flash *str
//  Item1: Ŀ  ǥ(1 - 16)
//  Item2: Ŀ  ǥ(1 - 4)
//  Item3:  ڿ FLASH(ѿ)
// -----------------------------------------------------------------------------
void Putsxyt_f(int x,int y,const char flash *str)
{
	Gotoxyt(x,y);						// Ŀ ġ 
	Puts_f(str);						// ڿ ǥ
}

// ============== ׷ LCD  ġ   ׸ ==============
// [μ] int x1
//	  int y1
//	  int x2
//	  int y2
// Item1:  xǥ
// Item2:  yǥ
// Item3:  xǥ
// Item4:  yǥ
// -----------------------------------------------------------------------------
void Line(int x1,int y1,int x2,int y2)
{
int i,vdx,vdy,vix,viy,vinc,plot,plotx,ploty,x = 0,y = 0;

	vdx = x2 - x1;						// vdx = x2 - x1
	vdy = y2 - y1;						// vdy = y2 - y1
	vix = abs(vdx);						// vix = |vdx|
	viy = abs(vdy); 					// vix = |vdx|
	if(vix > viy) vinc = vix;				// vinc = vix ? viy;
	else vinc = viy;

	plotx = x1;
	ploty = y1;
	Putpixel(plotx,ploty,_screen_color);
	for(i = 0; i <= vinc; i++){
		x += vix;
		y += viy;
		plot = 0;
		if(x > vinc){
			x -= vinc;
			if(vdx > 0) plotx++;
			if(vdx < 0) plotx--;
			plot = 1;
		}
		if(y > vinc){
			y -= vinc;
			if(vdy > 0) ploty++;
			if(vdy < 0) ploty--;
			plot = 1;
		}
		if(plot)Putpixel(plotx,ploty,_screen_color);
	}
}

// ================================== ڽ ׸ ==============================
// [μ] int x1
//	  int y1
//	  int x2
//	  int y2
// Item1:  xǥ
// Item2:  yǥ
// Item3:  xǥ
// Item4:  yǥ
// -----------------------------------------------------------------------------
void Rectangle(int x1,int y1,int x2,int y2)
{
	Line(x1,y1,x2,y1);
	Line(x1,y1,x1,y2);
	Line(x1,y2,x2,y2);
	Line(x2,y1,x2,y2);
}

// ============================== ä ڽ ׸ ===========================
// [μ] int x1
//	  int y1
//	  int x2
//	  int y2
// Item1:  xǥ
// Item2:  yǥ
// Item3:  xǥ
// Item4:  yǥ
// -----------------------------------------------------------------------------
void Rectanglefill(int x1,int y1,int x2,int y2)
{
	for( ; y1 <= y2; y1++) Line(x1,y1,x2,y1);
}

// ===============================  ׸ ===================================
// [μ] int xx
//	  int yy
//	  float radius
// Item1:  xǥ
// Item2:  yǥ
// Item3: 
// -----------------------------------------------------------------------------
void Circle(int xx,int yy,int radius)
{
int y = radius,d = 3-(y*2),x = 0;

	while(x < y){
		Putpixel(xx+x,yy+y,_screen_color);
		_Plotcircle(xx,yy,x,y);				// Ī Ŵ
		if(d < 0) d += (x*4+6);
		else{
			d += ((x-y)*4+10);
			y--;
		}
		x++;
	}
	if(x == y) Putpixel(xx+x,yy+y,_screen_color);
}

// ====================== ׸⿡ Ǵ Ī Լ ========================
void _Plotcircle(int xx,int yy,int x,int y)
{
	Putpixel(xx-x,yy+y,_screen_color);
	Putpixel(xx+x,yy-y,_screen_color);
	Putpixel(xx-x,yy-y,_screen_color);
	Putpixel(xx-y,yy+x,_screen_color);
	Putpixel(xx+y,yy-x,_screen_color);
	Putpixel(xx-y,yy-x,_screen_color);
	Putpixel(xx+y,yy+x,_screen_color);
}

// ================================== Ÿ ׸ ===============================
// [μ] int xx
//	  int yy
//	  int a0
//	  int b0
// Item1:  xǥ
// Item2:  yǥ
// Item3:  ݰ
// Item4:  ݰ
// -----------------------------------------------------------------------------
void Ellipse(int xx,int yy,int a0,int b0)
{
int x = 0,y = b0;
long a = a0,b = b0,a2 = a*a,a22 = 2*a2,b2 = b*b,b22 = 2*b2,d,dx,dy;

	d = b2-a2*b+a2/4L;
	dx=0L;
	dy=a22*b;
	while(dx < dy){
		symmetry4(xx,yy,x,y);
		if(d > 0){
			y--;
			dy-=a22;
			d-=dy;
		}
		x++;
		dx+=b22;
		d+=b2+dx;
	}
	d+=(3*(a2-b2)/2L-(dx+dy))/2L;
	while(y >= 0){
		symmetry4(xx,yy,x,y);
		if(d < 0){
			x++;
			dx+=b22;
			d+=dx;
		}
		y--;
		dy-=a22;
		d+=a2-dy;
	}
}

// ======================= Ÿ ׸⿡ Ǵ Ī Լ =====================
void symmetry4(int xx,int yy,int x,int y)
{
	Putpixel(xx-x,yy+y,_screen_color);
	Putpixel(xx+x,yy-y,_screen_color);
	Putpixel(xx-x,yy-y,_screen_color);
	Putpixel(xx+x,yy+y,_screen_color);
}

// =============================== ȭ鿡   ============================
// [μ] int x,int y,int color
// Item1:  ũ(0 - 127)
// Item2:  ũ(0 - 63)
// Item3: (_WHITE,_BLACK)
// -----------------------------------------------------------------------------
void Putpixel(int x,int y,char color)
{
unsigned char uch;
int page;
int mask_data = 0x01;

// page  BITġ 
	page = y >> 3;						// page = y / 8
	mask_data = mask_data << (y & 0x07);			// mask_data = 1 << (y%8)		

// DD RAM ġ 
	GLCD_Command(0xB0				 + page);			// page set
	GLCD_Command(0x10				 + (x >> 4));		// x address set
	GLCD_Command(0x00				 + (x & 0x0f));
//  
	uch = GLCD_Dread();					//   dummy
	uch = GLCD_Dread();					//  
	if(color == 0){
		mask_data = ~mask_data;				// mask data  0000 0001 -> 1111 1110
		uch = uch & mask_data;				// ش BIT 
	}
	else uch |= mask_data;

// DD RAM ġ 
	GLCD_Command(0xB0				 + page);			// page set
	GLCD_Command(0x10				 + (x >> 4));		// x address set
	GLCD_Command(0x00				 + (x & 0x0f));
//  
	GLCD_Dwrite(uch);					//  write
}

// ========================= ȭ ι 1BYTE  =======================
// [μ] int x,int y,unsigned char data,char color
// item1:  ũ(0 - 127)
// item2:  ũ(0 - 63)
// item3: Ÿ
// item4: 
// ------------------------------------------------------------------------------
void Putpixelb(int x,int y,unsigned char datac,char color)
{
unsigned char uch;
int page,s_cnt;
unsigned mask_data = 0xff,datau;

// page  BITġ 
	page = y >> 3;						// page = y / 8
	s_cnt = y & 0x07;					// shift cnt = y%8		
	mask_data = mask_data << s_cnt;				// mask data  0111 1101 -> 1111 1010
	datau = datac << s_cnt;					// ǥ  

// DD RAM ġ 
	GLCD_Command(0xB0				 + page);			// page set
	GLCD_Command(0x10				 + (x >> 4));		// x address set
	GLCD_Command(0x00				 + (x & 0x0f));
	
//  
	uch = GLCD_Dread();					//   dummy
	uch = GLCD_Dread();					//  
	if(color == 0) uch = uch & ~datau;			// NEW  & ~
	else{
		uch = uch & ~mask_data;				//  SKIP
		uch = uch | datau;				// NEW  OR 
	}
// DD RAM ġ 
	GLCD_Command(0xB0				 + page);			// page set
	GLCD_Command(0x10				 + (x >> 4));		// x address set
	GLCD_Command(0x00				 + (x & 0x0f));
//  
	GLCD_Dwrite(uch);					//  write
	if(s_cnt != 0 && page < 8){				// 1Byte  ǥ  page 0-7 ʰ ?
		datau = datau >> 8;				//   ε
		mask_data = mask_data >> 8;			//  ũ ε
// DD RAM+1 ġ 
		GLCD_Command(0xB0				 + page+1);		// page set
		GLCD_Command(0x10				 + (x >> 4));	// x address set
		GLCD_Command(0x00				 + (x & 0x0f));
//  
		uch = GLCD_Dread();				//   dummy
		uch = GLCD_Dread();				//  
		if(color == 0) uch = uch & ~datau;		// NEW  & ~
		else{
			uch = uch & ~mask_data;			//  SKIP
			uch = uch | datau;			// NEW  OR 
		}
// DD RAM+1 ġ 
		GLCD_Command(0xB0				 + page+1);		// page set
		GLCD_Command(0x10				 + (x >> 4));	// x address set
		GLCD_Command(0x00				 + (x & 0x0f));
//  
		GLCD_Dwrite(uch);				//  write
	}
}

// ========================= Ʈ     =========================
// [μ] unsigned int	c
// Item1:  
// ------------------------------------------------------------------------------
void _Putch(unsigned int c)
{
unsigned char *image;
int ch,i,curx1 = _screen_curx,cury1 = _screen_cury;

	if(c & 0x8000){						// ѱ ڵ Ÿ
		image = _GetHanImage(c);			// ѱ  
		for(i = 0; i < 16; i++){
			ch = *image++;				// ѱ  
			Putpixelb(curx1,cury1,ch,_screen_color);
			if(curx1 < 127) curx1++;		// Ŀ   
		}
		cury1 = _screen_cury+8;				// Yǥ+8
		if(cury1 < 64){
			curx1 = _screen_curx;			// Xǥ 
			for(i = 0; i < 16; i++){
				ch = *image++;			// Data Read
				Putpixelb(curx1,cury1,ch,_screen_color);
				if(curx1 < 127) curx1++;	// Ŀ   
			}
		}
		_screen_curx += 16;				// Ŀ   
		if(_screen_curx >= 128){
			_screen_curx = 0;
			_screen_cury += 16;			// Ŀ   
			if(_screen_cury >= 64) _screen_cury = 0;
		}
	}
	else{							//  ڵ Ÿ
		if(c == 0x0a){
			_screen_cury += 16;			// Ŀ   
			if(_screen_cury >= 64) _screen_cury = 0;// Ŀ   ˻
		}
		else if(c == 0x0d) _screen_curx = 0;		// Carrage Return
		else{
			image = _GetAscImage(c);		//   
			for(i = 0; i < 8; i++){
				ch = *image++;			// Data Read
				Putpixelb(curx1,cury1,ch,_screen_color);
				if(curx1 < 127) curx1++;	// Ŀ   
			}
			cury1 = _screen_cury+8;			// Yǥ+8
			if(cury1 < 64){
				curx1 = _screen_curx;		// Xǥ 
				for(i = 0; i < 8; i++){
					ch = *image++;		// Data Read
					Putpixelb(curx1,cury1,ch,_screen_color);
					if(curx1 < 127) curx1++;// Ŀ   
				}
			}
			_screen_curx += 8;			// Ŀ   
			if(_screen_curx >= 128){
				_screen_curx = 0;
				_screen_cury += 16;		// Ŀ   
				if(_screen_cury >= 64) _screen_cury = 0;
			}
		}
	}
}

// ======================== ѱ Ʈ Ÿ   ======================
//  [μ] unsigned c
//  Item1: ȯ Ÿ
//   : ȯ  
// ------------------------------------------------------------------------------
void *_GetHanImage(unsigned c)
{
unsigned h, h1, h2, h3, type1, type2, type3, pos;

	static char idxtbl1[] = {				// ʼ ε ̺
		 0,  0,  1,  2,  3,  4,  5,  6,
		 7,  8,  9, 10, 11, 12, 13, 14,
		15, 16, 17, 18, 19,  0,  0,  0,
		 0,  0,  0,  0,  0,  0,  0,  0
	};
	static char idxtbl2[] = {				// ߼ ε ̺
		 0,  0,  0,  1,  2,  3,  4,  5,
		 0,  0,  6,  7,  8,  9, 10, 11,
		 0,  0, 12, 13, 14, 15, 16, 17,
		 0,  0, 18, 19, 20, 21,  0,  0
	};
	static char idxtbl3[] = {				//  ε ̺
		 0,  0,  1,  2,  3,  4,  5,  6,
		 7,  8,  9, 10, 11, 12, 13, 14,
		15, 16,  0, 17, 18, 19, 20, 21,
		22, 23, 24, 25, 26, 27,  0,  0
    };
	static char type1tbl_no[]  = {				// ߼  ʼ /ħ 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 3,
		3, 3, 1, 2, 4, 4, 4, 2, 1, 3, 0
	};
	static char type1tbl_yes[] = {				// ߼  ʼ /ħ 
		5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 7,
		7, 7, 6, 6, 7, 7, 7, 6, 6, 7, 5
	};
	static char type3tbl[] = {				// ߼   
		0, 0, 2, 0, 2, 1, 2, 1, 2, 3, 0,
		2, 1, 3, 3, 1, 2, 1, 3, 3, 1, 1
	};

	h1 = (c >> 10) & 0x1F;					// ʼ ڵ
	h2 = (c >> 5)  & 0x1F;					// ߼ ڵ
	h3 = c	       & 0x1F;					//  ڵ
                                        			
	h1 = idxtbl1[h1];					// ʼ ε ڵ
	h2 = idxtbl2[h2];					// ߼ ε ڵ
	h3 = idxtbl3[h3];					//  ε ڵ

	type1 = h3 ? type1tbl_yes[h2] : type1tbl_no[h2];
	type2 = ((h1 == 0 || h1 == 1 || h1 == 16) ? 0 : 1) + (h3 ? 2 : 0);
	type3 = type3tbl[h2];

	if(h1){
		h = h1-1;					// ʼ[8][19][32] -> ʼ[152][32]
		pos = type1*19;
		memcpyf(ib, HanFont1[pos+h], 32);
	}
	else memset(ib, 0, 32);
	if(h2){
		h = h2-1;
		pos = type2*21;
		_memor(ib, HanFont2[pos+h], 32);		// ߼[4][21][32] -> ߼[84][32]
	}
	if(h3){
		h = h3-1;
		pos = type3*27;
		_memor(ib, HanFont3[pos+h], 32);		// [4][27][32] -> [108][32]
	}
	return ib;
}

// ======================  ѱ Ʈ Ѵ. ==========================
//  [μ] unsigned char *s1
//	   unsigned char flash *s2
//	   int	len
//  Item1:  
//  Item2: ε 
//  Item3: 
// ------------------------------------------------------------------------------
void _memor(unsigned char *s1,unsigned char flash *s2, int len)
{
	do{	
		*s1++ |= *s2++;
	}while (--len);
}

// =======================  Ʈ  ε ===============================
//  [μ] char c
//  Item1: ȯ Ÿ
//   : ȯ  
// -----------------------------------------------------------------------------
unsigned char* _GetAscImage(int c)
{
int i;

        for(i = 0; i < 16; i++) ascii_fbuf[i] = AscFont16[c][i];
	return ascii_fbuf;
}

// ===================== ϼ ڵ带  ȯ.=========================
// [μ] char *buf
// Item1: ȯ ڿ 
//  : ȯ   -> han_conv_buf[101]
// -----------------------------------------------------------------------------
void Han_Conv(char *buf)
{
unsigned char temp[2];
int  i,j,len;
unsigned lpos,code;

	len = strlen(buf);
	for(i = j = 0; i < len; i++){
		temp[0] = buf[i];
		if(temp[0] >= 0xb0 && temp[0] <= 0xc8){
			temp[1] = buf[++i];
			if(temp[1] >= 0xa1 && temp[1] <= 0xfe){
				lpos = (unsigned)(((unsigned)temp[0]-0xb0)*94 + ((unsigned)temp[1]-0xa1));
				code = Conv_Tbl[lpos];		// Data Read
				han_conv_buf[j++] = (char)(code >> 8);
				han_conv_buf[j++] = (char)(code & 0xff);
			}
		}
		else if(temp[0] == 0xa3){
			temp[1] = buf[++i];
			han_conv_buf[j++] = 0xda;
			if(temp[1] >= 0xa1 && temp[1] <= 0xbf) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xc0 && temp[1] <= 0xdf) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xe0 && temp[1] <= 0xee) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xef && temp[1] <= 0xfd) han_conv_buf[j++] = temp[1] - 0x5e;
		}
		else if(temp[0] == 0xa1){
			temp[1] = buf[++i];
			if(temp[1] == 0xa1){
				han_conv_buf[j++] = 0xd9;
				han_conv_buf[j++] = 0x31;
			}
			else{
				han_conv_buf[j++] = temp[0];
				han_conv_buf[j++] = temp[1];
			}
		}
		else han_conv_buf[j++] = temp[0];
	}
	han_conv_buf[j] = 0;					// ڿ  ǥ
}

// =============== ϼ(FLASH) ڵ带 (SRAM) ȯ.==================
// [μ] char flash *buf
// Item1: ȯ ڿ  FLASH
//  : ȯ   -> han_conv_buf[101]
// -----------------------------------------------------------------------------
void Han_Conv_f(char flash *buf)
{
unsigned char temp[2];
int  i,j,len;
unsigned lpos,code;

	len = strlenf(buf);
	for(i = j = 0; i < len; i++){
		temp[0] = buf[i];
		if(temp[0] >= 0xb0 && temp[0] <= 0xc8){
			temp[1] = buf[++i];
			if(temp[1] >= 0xa1 && temp[1] <= 0xfe){
				lpos = (unsigned)(((unsigned)temp[0]-0xb0)*94 + ((unsigned)temp[1]-0xa1));
				code = Conv_Tbl[lpos];		// Data Read
				han_conv_buf[j++] = (char)(code >> 8);
				han_conv_buf[j++] = (char)(code & 0xff);
			}
		}
		else if(temp[0] == 0xa3){
			temp[1] = buf[++i];
			han_conv_buf[j++] = 0xda;
			if(temp[1] >= 0xa1 && temp[1] <= 0xbf) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xc0 && temp[1] <= 0xdf) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xe0 && temp[1] <= 0xee) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xef && temp[1] <= 0xfd) han_conv_buf[j++] = temp[1] - 0x5e;
		}
		else if(temp[0] == 0xa1){
			temp[1] = buf[++i];
			if(temp[1] == 0xa1){
				han_conv_buf[j++] = 0xd9;
				han_conv_buf[j++] = 0x31;
			}
			else{
				han_conv_buf[j++] = temp[0];
				han_conv_buf[j++] = temp[1];
			}
		}
		else han_conv_buf[j++] = temp[0];
	}
	han_conv_buf[j] = 0;					// ڿ  ǥ
}

// ============================ ׷ LCD ʱȭ ==============================
// [μ] void
// [] 128*64
// -----------------------------------------------------------------------------
void Lcd_Init(void)
{
// ׷ LCD 
	PORTE &= 0xbf;						// PORTE.6(RST\) = 0
	delay_ms(200);						// reset ð 
	PORTE |= 0x40;						// PORTE.6(RST\) = 1

	GLCD_Command(0xE2);
	GLCD_Command(0x20				+3);  
	GLCD_Command(0x2F);  
	GLCD_Command(0x81				);
	GLCD_Command(0x31);					//LCD CONTRAST 
	GLCD_Command(0xC8);
//	GLCD_Command(HORIZONTAL_REVERSE);
	GLCD_Command(0xAF				);

	Cleardevice();						// LCD Clear
	Backlight_Ctrl(1);					// LCD BACKlight ON
}

// =================================== BUSY Check ============================
// [μ] void
// ---------------------------------------------------------------------------
void GLCD_Busy(void)
{
unsigned char i,ch;

	PORTA = 0xff;						// PORTA = PULL UP
	DDRA = 0x00;						// LCD_D[0..7] INPUT Mode Set

	PORTE &= ~0x10;						// PORTE.4 :: LCD_E = 0
	PORTE &= ~0x20;						// PORTE.5 :: LCD RS = 0 :: Instruction Set
	(*(unsigned char *) 0x65) |= 0x01;						// PORTG.0 :: LCD_R/W\ = Read

	PORTC &= ~0x01;						// PORTC.0 = LCD_CS1 = 0
	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
	for(i = 0; i < 3; i++);					// delay
	ch = PINA & 0x80;					// LCD DATA Read :: BUSY BIT
	PORTE &= ~0x10;						// PORTE.4 :: LCD_E = 0
	PORTC |= 0x01;						// PORTC.0 = LCD_CS1 = 1
	for(i = 0; i < 3; i++);	
	while(ch == 0x80){
		PORTC &= ~0x01;					// PORTC.0 = LCD_CS1 = 0
		PORTE |= 0x10;					// PORTE.4 :: LCD_E = 1
		for(i = 0; i < 3; i++);	
		ch = PINA & 0x80;				// LCD DATA Read :: BUSY BIT
		PORTE &= ~0x10;					// PORTE.4 :: LCD_E = 0
		PORTC |= 0x01;					// PORTC.0 = LCD_CS1 = 1
		for(i = 0; i < 3; i++);	
	}
}

// ============================== COMMAND  write =======================
// [μ] unsigned char uch
// Item1: 
// ---------------------------------------------------------------------------
void GLCD_Command(unsigned char uch)
{
int i;

	GLCD_Busy();						// BUSY Check
	DDRA = 0xff;						// LCD_D[0..7] OUTPUT Mode Set

	PORTC &= ~0x01;						// PORTC.0 = LCD_CS1 = 0
	PORTE &= ~0x10;						// PORTE.4 :: LCD_E = 0
	PORTE &= ~0x20;						// PORTE.5 :: LCD RS = 0 :: Instruction Set
	(*(unsigned char *) 0x65) &= ~0x01;						// PORTG.0 :: LCD_R/W\ = Write	
	PORTA = uch;						// PORTA = uch

	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
	for(i = 0; i < 3; i++);	
	PORTE &= ~0x10;						// PORTE.4 :: LCD_E = 0
	PORTC |= 0x01;						// PORTC.0 = LCD_CS1 = 1
	for(i = 0; i < 3; i++);					// delay
}

// ===================================  write ==========================
// [μ] unsigned char uch
// Item1: 
// ---------------------------------------------------------------------------
void GLCD_Dwrite(unsigned char uch)
{
int i;

	GLCD_Busy();						// BUSY Check
	DDRA = 0xff;						// LCD_D[0..7] OUTPUT Mode Set
	PORTC &= ~0x01;						// PORTC.0 = LCD_CS1 = 0
	PORTE &= ~0x10;						// PORTE.4 :: LCD_E = 0
	PORTE |= 0x20;						// PORTE.5 :: LCD RS = 1 :: Data Set
	(*(unsigned char *) 0x65) &= ~0x01;						// PORTG.0 :: LCD_R/W\ = Write	
	PORTA = uch;						// PORTA = uch

	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
	for(i = 0; i < 3; i++);	
	PORTE &= ~0x10;						// PORTE.4 :: LCD_E = 0
	PORTC |= 0x01;						// PORTC.0 = LCD_CS1 = 1
	for(i = 0; i < 3; i++);					// delay
}

// ===================================  read ===========================
// [μ] void
// [] (0-0xff)
// ---------------------------------------------------------------------------
unsigned char GLCD_Dread(void)
{
unsigned char i,uch;

	GLCD_Busy();						// BUSY Check
	PORTA = 0xff;						// PORTA = PULL UP
	DDRA = 0x00;						// LCD_D[0..7] INPUT Mode Set

	PORTC &= ~0x01;						// PORTC.0 = LCD_CS1 = 0
	PORTE &= ~0x10;						// PORTE.4 :: LCD_E = 0
	PORTE |= 0x20;						// PORTE.5 :: LCD RS = 1 :: Data Set
	(*(unsigned char *) 0x65) |= 0x01;						// PORTG.0 :: LCD_R/W\ = Read	

	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
	for(i = 0; i < 5; i++);					// delay
	uch = PINA & 0xff;					// LCD DATA Read
	PORTE &= ~0x10;						// PORTE.4 :: LCD_E = 0
	PORTC |= 0x01;						// PORTC.0 = LCD_CS1 = 1
	for(i = 0; i < 3; i++);	
	return(uch);						//  read
}

// Լ 
void main_menu_disp(void);						//  ޴ ǥ

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
char buf[50];

	cpu_setup();							// cpu ʱȭ
	Lcd_Init();							// LCD ʱȭ
	main_menu_disp();						//  ޴ ǥ
	Putsxyt_f(1,1,"ϼ ѱ TEST");				// ׷ ǥ ڿ ǥ
	Putsxyt_f(1,2,"www.cpuplaza.com");				// ׷ ǥ ڿ ǥ
	while(1){
		if(com1_rx_eflg){					// COM1  ˻
			if(com1_rx_data == '0') main_menu_disp();	//  ޴ ǥ
			else if(com1_rx_data == '1') Clrscr();		// ȭ 
			else if(com1_rx_data == '2') Cleardevice();	// ȭ 
			else if(com1_rx_data == '3') Putpixel(0,0,15);// ȼ ǥ
			else if(com1_rx_data == '4') Putpixelb(0,1,0xff,15);// Ʈ  ǥ()
			else if(com1_rx_data == '5') Putch('1');	// 1 ǥ
			else if(com1_rx_data == '6') Putchxy(16,2,'2');	// ׷ ǥ 1 ǥ
			else if(com1_rx_data == '7') Putchxyt(8,3,'3');	// ؽƮ ǥ 1 ǥ
			else if(com1_rx_data == '8'){
 				sprintf(buf,"");			// ѱ ڿ
				Puts(buf);				// ڿ ǥ
				Puts_f("");				// CODE ڿ ǥ
			}
			else if(com1_rx_data == '9'){
				sprintf(buf,"׽Ʈ1");
				Putsxy(10,3,buf);			// ׷ ǥ ڿ ǥ
				Putsxy_f(10,20,"׽Ʈ1");		// ׷ ǥ CODE ڿ ǥ
			}
			else if(com1_rx_data == 'a'){
				sprintf(buf,"׽Ʈ2");
				Putsxyt(4,2,buf);			// ؽƮ ǥ ڿ ǥ
				Putsxyt_f(4,3,"׽Ʈ2");		// ؽƮ ǥ ڿ ǥ
			}
			else if(com1_rx_data == 'b'){			//  پϰ ׸
				Line(0,0,127,0);			// 簢 ڽ
				Line(127,0,127,63);
				Line(127,63,0,63);
				Line(0,0,0,63);

				Line(0,32,127,32);			// +
				Line(64,0,64,63);

				Line(0,0,127,63);			// 밢
				Line(0,63,127,0);
			}
			else if(com1_rx_data == 'c') Rectangle(10,10,118,54);// 簢ڽ ׸
			else if(com1_rx_data == 'd') Rectanglefill(10,10,118,54);// ä 簢ڽ ׸
			else if(com1_rx_data == 'e') Circle(64,32,10);	//  ׸
			else if(com1_rx_data == 'f') Ellipse(64,32,20,10);// Ÿ ׸
			else if(com1_rx_data == 'g') Setcolor(15);	//   WHITE
			else if(com1_rx_data == 'h') Setcolor(0);	//   BLACK
			else if(com1_rx_data == 'i') Backlight_Ctrl(1);	// LCD BACKlight ON
			else if(com1_rx_data == 'j') Backlight_Ctrl(0);	// LCD BACKlight OFF
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
	return 0;
}

// =====================================  ޴ ǥ =======================
// [μ] void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("========== LCD Test Main =========\r\n");
	printf("- 0 : Main Menu Disp             -\r\n");
	printf("- 1 : Clrscr                     -\r\n");
	printf("- 2 : Cleardevice                -\r\n");
	printf("- 3 : Putpixel                   -\r\n");
	printf("- 4 : Putpixelb                  -\r\n");
	printf("- 5 : Putch                      -\r\n");
	printf("- 6 : Putchxy                    -\r\n");
	printf("- 7 : Putchxyt                   -\r\n");
	printf("- 8 : Puts                       -\r\n");
	printf("- 9 : Putsxy                     -\r\n");
	printf("- a : Putsxyt                    -\r\n");
	printf("- b : Line                       -\r\n");
	printf("- c : Rectangle                  -\r\n");
	printf("- d : Rectanglefill              -\r\n");
	printf("- e : Circle                     -\r\n");
	printf("- f : Ellipse                    -\r\n");
	printf("- g : Setcolor(_WHITE)           -\r\n");
	printf("- h : Setcolor(_BLACK)           -\r\n");
	printf("- i : Backlight ON               -\r\n");
	printf("- j : Backlight OFF              -\r\n");
	printf("----------------------------------\r\n");
}
